
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "parser.y"

/*
  OMPi OpenMP Compiler
  == Copyright since 2001 the OMPi Team
  == Department of Computer Science, University of Ioannina

  This file is part of OMPi.

  OMPi is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  OMPi is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with OMPi; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* parser.y */

/* 
 * 2010/11/10:
 *   dropped OpenMP-specific for parsing; fewer rules, less code
 * 2009/05/11:
 *   added AUTO schedule type
 * 2009/05/03:
 *   added ATNODE ompix clause
 */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <stdarg.h>
#include <ctype.h>
#include <assert.h>
#include "scanner.h"
#include "ompi.h"
#include "ast.h"
#include "symtab.h"
#include "ast_free.h"
#include "ast_copy.h"
#include "ast_vars.h"

void    check_uknown_var(char *name);
void    parse_error(int exitvalue, char *format, ...);
void    parse_warning(char *format, ...);
void    yyerror(char *s);
void    check_for_main_and_declare(astspec s, astdecl d);
void    add_declaration_links(astspec s, astdecl d);
astdecl fix_known_typename(astspec s);

aststmt pastree = NULL;       /* The generated AST */
aststmt pastree_stmt = NULL;  /* For when parsing statment strings */
astexpr pastree_expr = NULL;  /* For when parsing expression strings */
int     checkDecls = 1;       /* 0 when scanning strings (no context check) */
int     tempsave;
int     isTypedef  = 0;       /* To keep track of typedefs */

char    *parsingstring;       /* For error reporting when parsing string */


/* Line 189 of yacc.c  */
#line 142 "parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     START_SYMBOL_EXPRESSION = 258,
     START_SYMBOL_BLOCKLIST = 259,
     IDENTIFIER = 260,
     TYPE_NAME = 261,
     CONSTANT = 262,
     STRING_LITERAL = 263,
     PTR_OP = 264,
     INC_OP = 265,
     DEC_OP = 266,
     LEFT_OP = 267,
     RIGHT_OP = 268,
     LE_OP = 269,
     GE_OP = 270,
     EQ_OP = 271,
     NE_OP = 272,
     AND_OP = 273,
     OR_OP = 274,
     MUL_ASSIGN = 275,
     DIV_ASSIGN = 276,
     MOD_ASSIGN = 277,
     ADD_ASSIGN = 278,
     SUB_ASSIGN = 279,
     LEFT_ASSIGN = 280,
     RIGHT_ASSIGN = 281,
     AND_ASSIGN = 282,
     XOR_ASSIGN = 283,
     OR_ASSIGN = 284,
     SIZEOF = 285,
     TYPEDEF = 286,
     EXTERN = 287,
     STATIC = 288,
     AUTO = 289,
     REGISTER = 290,
     RESTRICT = 291,
     CHAR = 292,
     SHORT = 293,
     INT = 294,
     LONG = 295,
     SIGNED = 296,
     UNSIGNED = 297,
     FLOAT = 298,
     DOUBLE = 299,
     CONST = 300,
     VOLATILE = 301,
     VOID = 302,
     INLINE = 303,
     UBOOL = 304,
     UCOMPLEX = 305,
     UIMAGINARY = 306,
     STRUCT = 307,
     UNION = 308,
     ENUM = 309,
     ELLIPSIS = 310,
     CASE = 311,
     DEFAULT = 312,
     IF = 313,
     ELSE = 314,
     SWITCH = 315,
     WHILE = 316,
     DO = 317,
     FOR = 318,
     GOTO = 319,
     CONTINUE = 320,
     BREAK = 321,
     RETURN = 322,
     __BUILTIN_VA_ARG = 323,
     __BUILTIN_OFFSETOF = 324,
     __BUILTIN_TYPES_COMPATIBLE_P = 325,
     __ATTRIBUTE__ = 326,
     PRAGMA_OMP = 327,
     PRAGMA_OMP_THREADPRIVATE = 328,
     OMP_PARALLEL = 329,
     OMP_SECTIONS = 330,
     OMP_NOWAIT = 331,
     OMP_ORDERED = 332,
     OMP_SCHEDULE = 333,
     OMP_STATIC = 334,
     OMP_DYNAMIC = 335,
     OMP_GUIDED = 336,
     OMP_RUNTIME = 337,
     OMP_AUTO = 338,
     OMP_SECTION = 339,
     OMP_AFFINITY = 340,
     OMP_SINGLE = 341,
     OMP_MASTER = 342,
     OMP_CRITICAL = 343,
     OMP_BARRIER = 344,
     OMP_ATOMIC = 345,
     OMP_FLUSH = 346,
     OMP_PRIVATE = 347,
     OMP_FIRSTPRIVATE = 348,
     OMP_LASTPRIVATE = 349,
     OMP_SHARED = 350,
     OMP_DEFAULT = 351,
     OMP_NONE = 352,
     OMP_REDUCTION = 353,
     OMP_COPYIN = 354,
     OMP_NUMTHREADS = 355,
     OMP_COPYPRIVATE = 356,
     OMP_FOR = 357,
     OMP_IF = 358,
     OMP_TASK = 359,
     OMP_UNTIED = 360,
     OMP_TASKWAIT = 361,
     OMP_COLLAPSE = 362,
     PRAGMA_OMPIX = 363,
     OMPIX_TASKDEF = 364,
     OMPIX_IN = 365,
     OMPIX_OUT = 366,
     OMPIX_INOUT = 367,
     OMPIX_TASKSYNC = 368,
     OMPIX_UPONRETURN = 369,
     OMPIX_ATNODE = 370,
     OMPIX_DETACHED = 371,
     OMPIX_ATWORKER = 372,
     OMPIX_TASKSCHEDULE = 373,
     OMPIX_STRIDE = 374,
     OMPIX_START = 375,
     OMPIX_SCOPE = 376,
     OMPIX_NODES = 377,
     OMPIX_WORKERS = 378,
     OMPIX_LOCAL = 379,
     OMPIX_GLOBAL = 380,
     OMPIX_TIED = 381
   };
#endif
/* Tokens.  */
#define START_SYMBOL_EXPRESSION 258
#define START_SYMBOL_BLOCKLIST 259
#define IDENTIFIER 260
#define TYPE_NAME 261
#define CONSTANT 262
#define STRING_LITERAL 263
#define PTR_OP 264
#define INC_OP 265
#define DEC_OP 266
#define LEFT_OP 267
#define RIGHT_OP 268
#define LE_OP 269
#define GE_OP 270
#define EQ_OP 271
#define NE_OP 272
#define AND_OP 273
#define OR_OP 274
#define MUL_ASSIGN 275
#define DIV_ASSIGN 276
#define MOD_ASSIGN 277
#define ADD_ASSIGN 278
#define SUB_ASSIGN 279
#define LEFT_ASSIGN 280
#define RIGHT_ASSIGN 281
#define AND_ASSIGN 282
#define XOR_ASSIGN 283
#define OR_ASSIGN 284
#define SIZEOF 285
#define TYPEDEF 286
#define EXTERN 287
#define STATIC 288
#define AUTO 289
#define REGISTER 290
#define RESTRICT 291
#define CHAR 292
#define SHORT 293
#define INT 294
#define LONG 295
#define SIGNED 296
#define UNSIGNED 297
#define FLOAT 298
#define DOUBLE 299
#define CONST 300
#define VOLATILE 301
#define VOID 302
#define INLINE 303
#define UBOOL 304
#define UCOMPLEX 305
#define UIMAGINARY 306
#define STRUCT 307
#define UNION 308
#define ENUM 309
#define ELLIPSIS 310
#define CASE 311
#define DEFAULT 312
#define IF 313
#define ELSE 314
#define SWITCH 315
#define WHILE 316
#define DO 317
#define FOR 318
#define GOTO 319
#define CONTINUE 320
#define BREAK 321
#define RETURN 322
#define __BUILTIN_VA_ARG 323
#define __BUILTIN_OFFSETOF 324
#define __BUILTIN_TYPES_COMPATIBLE_P 325
#define __ATTRIBUTE__ 326
#define PRAGMA_OMP 327
#define PRAGMA_OMP_THREADPRIVATE 328
#define OMP_PARALLEL 329
#define OMP_SECTIONS 330
#define OMP_NOWAIT 331
#define OMP_ORDERED 332
#define OMP_SCHEDULE 333
#define OMP_STATIC 334
#define OMP_DYNAMIC 335
#define OMP_GUIDED 336
#define OMP_RUNTIME 337
#define OMP_AUTO 338
#define OMP_SECTION 339
#define OMP_AFFINITY 340
#define OMP_SINGLE 341
#define OMP_MASTER 342
#define OMP_CRITICAL 343
#define OMP_BARRIER 344
#define OMP_ATOMIC 345
#define OMP_FLUSH 346
#define OMP_PRIVATE 347
#define OMP_FIRSTPRIVATE 348
#define OMP_LASTPRIVATE 349
#define OMP_SHARED 350
#define OMP_DEFAULT 351
#define OMP_NONE 352
#define OMP_REDUCTION 353
#define OMP_COPYIN 354
#define OMP_NUMTHREADS 355
#define OMP_COPYPRIVATE 356
#define OMP_FOR 357
#define OMP_IF 358
#define OMP_TASK 359
#define OMP_UNTIED 360
#define OMP_TASKWAIT 361
#define OMP_COLLAPSE 362
#define PRAGMA_OMPIX 363
#define OMPIX_TASKDEF 364
#define OMPIX_IN 365
#define OMPIX_OUT 366
#define OMPIX_INOUT 367
#define OMPIX_TASKSYNC 368
#define OMPIX_UPONRETURN 369
#define OMPIX_ATNODE 370
#define OMPIX_DETACHED 371
#define OMPIX_ATWORKER 372
#define OMPIX_TASKSCHEDULE 373
#define OMPIX_STRIDE 374
#define OMPIX_START 375
#define OMPIX_SCOPE 376
#define OMPIX_NODES 377
#define OMPIX_WORKERS 378
#define OMPIX_LOCAL 379
#define OMPIX_GLOBAL 380
#define OMPIX_TIED 381




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 69 "parser.y"

  char      name[2048];  /* A general string */
  int       type;        /* A general integer */
  char     *string;      /* A dynamically allocated string (only for 2 rules) */
  symbol    symb;        /* A symbol */
  astexpr   expr;        /* An expression node in the AST */
  astspec   spec;        /* A declaration specifier node in the AST */
  astdecl   decl;        /* A declarator node in the AST */
  aststmt   stmt;        /* A statement node in the AST */
  ompcon    ocon;        /* An OpenMP construct */
  ompdir    odir;        /* An OpenMP directive */
  ompclause ocla;        /* An OpenMP clause */

  oxcon     xcon;        /* OMPi extensions */
  oxdir     xdir;
  oxclause  xcla;



/* Line 214 of yacc.c  */
#line 450 "parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 462 "parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  161
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2813

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  152
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  172
/* YYNRULES -- Number of rules.  */
#define YYNRULES  467
/* YYNRULES -- Number of states.  */
#define YYNSTATES  827

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   381

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     151,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   140,     2,     2,     2,   142,   135,     2,
     127,   128,   136,   137,   134,   138,   131,   141,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   148,   150,
     143,   149,   144,   147,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   129,     2,   130,   145,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   132,   146,   133,   139,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    13,    15,    18,    20,
      22,    24,    28,    30,    35,    39,    44,    48,    53,    57,
      61,    65,    69,    72,    75,    82,    90,    92,    96,    98,
     101,   104,   107,   110,   115,   122,   129,   136,   138,   140,
     142,   144,   146,   148,   150,   155,   157,   161,   165,   169,
     171,   175,   179,   181,   185,   189,   191,   195,   199,   203,
     207,   209,   213,   217,   219,   223,   225,   229,   231,   235,
     237,   241,   243,   247,   249,   255,   257,   261,   263,   265,
     267,   269,   271,   273,   275,   277,   279,   281,   283,   285,
     289,   291,   294,   298,   300,   302,   305,   307,   310,   312,
     315,   317,   320,   322,   326,   328,   329,   334,   336,   338,
     340,   342,   344,   346,   348,   350,   352,   354,   356,   358,
     360,   362,   364,   366,   368,   370,   372,   374,   379,   383,
     389,   395,   398,   401,   403,   405,   407,   410,   414,   417,
     419,   422,   424,   427,   429,   433,   435,   439,   442,   447,
     453,   459,   466,   469,   471,   475,   477,   481,   483,   485,
     487,   489,   491,   494,   496,   500,   504,   509,   514,   520,
     526,   533,   540,   545,   551,   556,   560,   565,   567,   570,
     573,   577,   579,   582,   584,   588,   590,   594,   597,   599,
     602,   604,   608,   610,   613,   615,   617,   620,   624,   627,
     631,   635,   640,   644,   649,   652,   656,   660,   665,   667,
     669,   673,   678,   680,   683,   687,   692,   695,   697,   700,
     704,   707,   710,   712,   714,   716,   718,   720,   722,   724,
     726,   730,   735,   739,   742,   743,   748,   750,   753,   755,
     757,   759,   761,   763,   766,   772,   780,   786,   792,   800,
     802,   809,   817,   825,   833,   842,   851,   860,   870,   877,
     885,   893,   902,   906,   909,   912,   915,   919,   921,   924,
     926,   928,   930,   932,   934,   935,   940,   941,   945,   946,
     952,   953,   958,   960,   963,   965,   967,   969,   971,   973,
     975,   977,   979,   981,   983,   985,   987,   989,   991,   993,
     996,  1001,  1002,  1005,  1009,  1011,  1013,  1014,  1020,  1021,
    1027,  1030,  1035,  1036,  1039,  1043,  1045,  1047,  1049,  1051,
    1056,  1057,  1065,  1066,  1074,  1079,  1081,  1083,  1085,  1087,
    1089,  1091,  1094,  1099,  1100,  1103,  1107,  1109,  1111,  1115,
    1117,  1120,  1124,  1128,  1131,  1136,  1137,  1140,  1144,  1146,
    1148,  1151,  1157,  1158,  1161,  1165,  1167,  1169,  1171,  1174,
    1180,  1181,  1184,  1188,  1190,  1192,  1195,  1200,  1201,  1204,
    1208,  1210,  1212,  1213,  1219,  1221,  1224,  1228,  1231,  1235,
    1240,  1244,  1248,  1252,  1255,  1259,  1263,  1268,  1269,  1274,
    1277,  1281,  1287,  1288,  1294,  1295,  1301,  1302,  1308,  1309,
    1315,  1316,  1322,  1327,  1332,  1333,  1341,  1342,  1348,  1350,
    1352,  1354,  1356,  1358,  1360,  1362,  1364,  1366,  1370,  1372,
    1376,  1378,  1380,  1384,  1385,  1391,  1392,  1395,  1399,  1404,
    1409,  1414,  1416,  1418,  1420,  1422,  1426,  1430,  1432,  1434,
    1435,  1440,  1443,  1444,  1450,  1451,  1454,  1458,  1463,  1468,
    1473,  1480,  1482,  1486,  1488,  1493,  1497,  1502,  1503,  1506,
    1510,  1515,  1520,  1525,  1527,  1529,  1531,  1535
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     153,     0,    -1,   224,    -1,     3,   175,    -1,     4,   217,
      -1,     5,    -1,     8,    -1,   155,     8,    -1,     5,    -1,
       7,    -1,   155,    -1,   127,   175,   128,    -1,   156,    -1,
     157,   129,   175,   130,    -1,     5,   127,   128,    -1,     5,
     127,   158,   128,    -1,   157,   127,   128,    -1,   157,   127,
     158,   128,    -1,   157,   131,     5,    -1,   157,     9,     5,
      -1,   157,   131,   207,    -1,   157,     9,   207,    -1,   157,
      10,    -1,   157,    11,    -1,   127,   204,   128,   132,   209,
     133,    -1,   127,   204,   128,   132,   209,   134,   133,    -1,
     173,    -1,   158,   134,   173,    -1,   157,    -1,    10,   159,
      -1,    11,   159,    -1,   160,   161,    -1,    30,   159,    -1,
      30,   127,   204,   128,    -1,    68,   127,   173,   134,   204,
     128,    -1,    69,   127,   204,   134,     5,   128,    -1,    70,
     127,   204,   134,   204,   128,    -1,   135,    -1,   136,    -1,
     137,    -1,   138,    -1,   139,    -1,   140,    -1,   159,    -1,
     127,   204,   128,   161,    -1,   161,    -1,   162,   136,   161,
      -1,   162,   141,   161,    -1,   162,   142,   161,    -1,   162,
      -1,   163,   137,   162,    -1,   163,   138,   162,    -1,   163,
      -1,   164,    12,   163,    -1,   164,    13,   163,    -1,   164,
      -1,   165,   143,   164,    -1,   165,   144,   164,    -1,   165,
      14,   164,    -1,   165,    15,   164,    -1,   165,    -1,   166,
      16,   165,    -1,   166,    17,   165,    -1,   166,    -1,   167,
     135,   166,    -1,   167,    -1,   168,   145,   167,    -1,   168,
      -1,   169,   146,   168,    -1,   169,    -1,   170,    18,   169,
      -1,   170,    -1,   171,    19,   170,    -1,   171,    -1,   171,
     147,   175,   148,   172,    -1,   172,    -1,   159,   174,   173,
      -1,   149,    -1,    20,    -1,    21,    -1,    22,    -1,    23,
      -1,    24,    -1,    25,    -1,    26,    -1,    27,    -1,    28,
      -1,    29,    -1,   173,    -1,   175,   134,   173,    -1,   172,
      -1,   178,   150,    -1,   178,   179,   150,    -1,   291,    -1,
     182,    -1,   182,   178,    -1,   183,    -1,   183,   178,    -1,
     194,    -1,   194,   178,    -1,   195,    -1,   195,   178,    -1,
     180,    -1,   179,   134,   180,    -1,   196,    -1,    -1,   196,
     149,   181,   208,    -1,    31,    -1,    32,    -1,    33,    -1,
      34,    -1,    35,    -1,    47,    -1,    37,    -1,    38,    -1,
      39,    -1,    40,    -1,    43,    -1,    44,    -1,    41,    -1,
      42,    -1,    49,    -1,    50,    -1,    51,    -1,   184,    -1,
     191,    -1,   207,    -1,   185,   132,   186,   133,    -1,   185,
     132,   133,    -1,   185,     5,   132,   186,   133,    -1,   185,
     207,   132,   186,   133,    -1,   185,     5,    -1,   185,   207,
      -1,    52,    -1,    53,    -1,   187,    -1,   186,   187,    -1,
     188,   189,   150,    -1,   188,   150,    -1,   183,    -1,   183,
     188,    -1,   194,    -1,   194,   188,    -1,   190,    -1,   189,
     134,   190,    -1,   196,    -1,   196,   148,   176,    -1,   148,
     176,    -1,    54,   132,   192,   133,    -1,    54,     5,   132,
     192,   133,    -1,    54,   132,   192,   134,   133,    -1,    54,
       5,   132,   192,   134,   133,    -1,    54,     5,    -1,   193,
      -1,   192,   134,   193,    -1,   154,    -1,   154,   149,   176,
      -1,    45,    -1,    36,    -1,    46,    -1,    48,    -1,   197,
      -1,   198,   197,    -1,     5,    -1,   127,   196,   128,    -1,
     197,   129,   130,    -1,   197,   129,   199,   130,    -1,   197,
     129,   173,   130,    -1,   197,   129,   199,   173,   130,    -1,
     197,   129,    33,   173,   130,    -1,   197,   129,    33,   199,
     173,   130,    -1,   197,   129,   199,    33,   173,   130,    -1,
     197,   129,   136,   130,    -1,   197,   129,   199,   136,   130,
      -1,   197,   127,   200,   128,    -1,   197,   127,   128,    -1,
     197,   127,   203,   128,    -1,   136,    -1,   136,   199,    -1,
     136,   198,    -1,   136,   199,   198,    -1,   194,    -1,   199,
     194,    -1,   201,    -1,   201,   134,    55,    -1,   202,    -1,
     201,   134,   202,    -1,   178,   196,    -1,   178,    -1,   178,
     205,    -1,     5,    -1,   203,   134,     5,    -1,   188,    -1,
     188,   205,    -1,   198,    -1,   206,    -1,   198,   206,    -1,
     127,   205,   128,    -1,   129,   130,    -1,   206,   129,   130,
      -1,   129,   173,   130,    -1,   206,   129,   173,   130,    -1,
     129,   136,   130,    -1,   206,   129,   136,   130,    -1,   127,
     128,    -1,   206,   127,   128,    -1,   127,   200,   128,    -1,
     206,   127,   200,   128,    -1,     6,    -1,   173,    -1,   132,
     209,   133,    -1,   132,   209,   134,   133,    -1,   208,    -1,
     210,   208,    -1,   209,   134,   208,    -1,   209,   134,   210,
     208,    -1,   211,   149,    -1,   212,    -1,   211,   212,    -1,
     129,   176,   130,    -1,   131,     5,    -1,   131,   207,    -1,
     214,    -1,   215,    -1,   219,    -1,   220,    -1,   221,    -1,
     223,    -1,   234,    -1,   310,    -1,     5,   148,   213,    -1,
      56,   176,   148,   213,    -1,    57,   148,   213,    -1,   132,
     133,    -1,    -1,   132,   216,   217,   133,    -1,   218,    -1,
     217,   218,    -1,   177,    -1,   213,    -1,   235,    -1,   303,
      -1,   150,    -1,   175,   150,    -1,    58,   127,   175,   128,
     213,    -1,    58,   127,   175,   128,   213,    59,   213,    -1,
      60,   127,   175,   128,   213,    -1,    61,   127,   175,   128,
     213,    -1,    62,   213,    61,   127,   175,   128,   150,    -1,
     222,    -1,    63,   127,   150,   150,   128,   213,    -1,    63,
     127,   175,   150,   150,   128,   213,    -1,    63,   127,   150,
     175,   150,   128,   213,    -1,    63,   127,   150,   150,   175,
     128,   213,    -1,    63,   127,   175,   150,   175,   150,   128,
     213,    -1,    63,   127,   175,   150,   150,   175,   128,   213,
      -1,    63,   127,   150,   175,   150,   175,   128,   213,    -1,
      63,   127,   175,   150,   175,   150,   175,   128,   213,    -1,
      63,   127,   177,   150,   128,   213,    -1,    63,   127,   177,
     175,   150,   128,   213,    -1,    63,   127,   177,   150,   175,
     128,   213,    -1,    63,   127,   177,   175,   150,   175,   128,
     213,    -1,    64,     5,   150,    -1,    65,   150,    -1,    66,
     150,    -1,    67,   150,    -1,    67,   175,   150,    -1,   225,
      -1,   224,   225,    -1,   226,    -1,   177,    -1,   311,    -1,
     227,    -1,   230,    -1,    -1,   178,   196,   228,   215,    -1,
      -1,   196,   229,   215,    -1,    -1,   178,   196,   231,   233,
     215,    -1,    -1,   196,   232,   233,   215,    -1,   177,    -1,
     233,   177,    -1,   237,    -1,   244,    -1,   252,    -1,   259,
      -1,   263,    -1,   267,    -1,   277,    -1,   279,    -1,   284,
      -1,   289,    -1,   271,    -1,   283,    -1,   286,    -1,   282,
      -1,   213,    -1,   238,   236,    -1,    72,    74,   239,   151,
      -1,    -1,   239,   240,    -1,   239,   134,   240,    -1,   241,
      -1,   292,    -1,    -1,   103,   127,   242,   175,   128,    -1,
      -1,   100,   127,   243,   175,   128,    -1,   245,   222,    -1,
      72,   102,   246,   151,    -1,    -1,   246,   247,    -1,   246,
     134,   247,    -1,   248,    -1,   292,    -1,    76,    -1,    77,
      -1,    78,   127,   251,   128,    -1,    -1,    78,   127,   251,
     134,   249,   175,   128,    -1,    -1,    78,   127,    85,   134,
     250,   175,   128,    -1,   107,   127,     7,   128,    -1,    79,
      -1,    80,    -1,    81,    -1,    82,    -1,    83,    -1,     1,
      -1,   253,   256,    -1,    72,    75,   254,   151,    -1,    -1,
     254,   255,    -1,   254,   134,   255,    -1,   292,    -1,    76,
      -1,   132,   257,   133,    -1,   236,    -1,   258,   236,    -1,
     257,   258,   236,    -1,    72,    84,   151,    -1,   260,   236,
      -1,    72,    86,   261,   151,    -1,    -1,   261,   262,    -1,
     261,   134,   262,    -1,   292,    -1,    76,    -1,   264,   222,
      -1,    72,    74,   102,   265,   151,    -1,    -1,   265,   266,
      -1,   265,   134,   266,    -1,   241,    -1,   248,    -1,   292,
      -1,   268,   256,    -1,    72,    74,    75,   269,   151,    -1,
      -1,   269,   270,    -1,   269,   134,   270,    -1,   241,    -1,
     292,    -1,   272,   236,    -1,    72,   104,   273,   151,    -1,
      -1,   273,   274,    -1,   273,   134,   274,    -1,   275,    -1,
     292,    -1,    -1,   103,   127,   276,   175,   128,    -1,   105,
      -1,   278,   236,    -1,    72,    87,   151,    -1,   280,   236,
      -1,    72,    88,   151,    -1,    72,    88,   281,   151,    -1,
     127,     5,   128,    -1,    72,   106,   151,    -1,    72,    89,
     151,    -1,   285,   219,    -1,    72,    90,   151,    -1,    72,
      91,   151,    -1,    72,    91,   287,   151,    -1,    -1,   127,
     288,   301,   128,    -1,   290,   236,    -1,    72,    77,   151,
      -1,    73,   127,   302,   128,   151,    -1,    -1,    92,   293,
     127,   301,   128,    -1,    -1,   101,   294,   127,   301,   128,
      -1,    -1,    93,   295,   127,   301,   128,    -1,    -1,    94,
     296,   127,   301,   128,    -1,    -1,    95,   297,   127,   301,
     128,    -1,    96,   127,    95,   128,    -1,    96,   127,    97,
     128,    -1,    -1,    98,   298,   127,   300,   148,   301,   128,
      -1,    -1,    99,   299,   127,   301,   128,    -1,   137,    -1,
     136,    -1,   138,    -1,   135,    -1,   145,    -1,   146,    -1,
      18,    -1,    19,    -1,     5,    -1,   301,   134,     5,    -1,
       5,    -1,   302,   134,     5,    -1,   304,    -1,   305,    -1,
     108,   113,   151,    -1,    -1,   108,   118,   306,   307,   151,
      -1,    -1,   307,   308,    -1,   307,   134,   308,    -1,   119,
     127,   173,   128,    -1,   120,   127,   173,   128,    -1,   121,
     127,   309,   128,    -1,   126,    -1,   105,    -1,   122,    -1,
     123,    -1,   123,   134,   125,    -1,   123,   134,   124,    -1,
     311,    -1,   319,    -1,    -1,   313,   227,   312,   215,    -1,
     313,   227,    -1,    -1,   108,   109,   314,   315,   151,    -1,
      -1,   315,   316,    -1,   315,   134,   316,    -1,   110,   127,
     317,   128,    -1,   111,   127,   317,   128,    -1,   112,   127,
     317,   128,    -1,    98,   127,   300,   148,   317,   128,    -1,
     318,    -1,   317,   134,   318,    -1,     5,    -1,     5,   129,
     173,   130,    -1,   320,   323,   150,    -1,   108,   104,   321,
     151,    -1,    -1,   321,   322,    -1,   321,   134,   322,    -1,
     115,   127,   136,   128,    -1,   115,   127,   173,   128,    -1,
     117,   127,   173,   128,    -1,   126,    -1,   105,    -1,   116,
      -1,     5,   127,   128,    -1,     5,   127,   158,   128,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   302,   302,   303,   304,   321,   342,   346,   369,   392,
     396,   400,   408,   412,   422,   429,   436,   440,   444,   448,
     457,   461,   465,   469,   473,   477,   485,   489,   497,   501,
     505,   509,   516,   520,   529,   534,   539,   548,   552,   556,
     560,   564,   568,   576,   580,   588,   592,   596,   600,   608,
     612,   616,   624,   628,   632,   640,   644,   648,   652,   656,
     664,   668,   672,   680,   684,   692,   696,   704,   708,   716,
     720,   728,   732,   740,   744,   752,   756,   764,   768,   772,
     776,   780,   784,   788,   792,   796,   800,   804,   812,   816,
     824,   838,   853,   860,   868,   872,   876,   880,   884,   888,
     892,   896,   904,   908,   922,   939,   938,   961,   966,   970,
     974,   978,   986,   990,   994,   998,  1002,  1006,  1010,  1014,
    1018,  1022,  1026,  1030,  1034,  1038,  1042,  1050,  1054,  1058,
    1073,  1080,  1087,  1098,  1102,  1110,  1114,  1122,  1126,  1134,
    1138,  1142,  1146,  1154,  1158,  1166,  1170,  1174,  1182,  1186,
    1198,  1202,  1214,  1226,  1230,  1238,  1242,  1250,  1254,  1258,
    1266,  1274,  1278,  1291,  1295,  1303,  1307,  1311,  1315,  1319,
    1323,  1327,  1331,  1335,  1339,  1343,  1347,  1355,  1359,  1363,
    1367,  1375,  1379,  1387,  1391,  1399,  1403,  1411,  1415,  1419,
    1427,  1431,  1439,  1443,  1451,  1455,  1459,  1467,  1471,  1475,
    1479,  1483,  1487,  1491,  1495,  1499,  1503,  1507,  1515,  1523,
    1527,  1531,  1539,  1543,  1547,  1551,  1559,  1567,  1571,  1579,
    1583,  1587,  1601,  1605,  1609,  1613,  1617,  1621,  1625,  1630,
    1639,  1643,  1647,  1655,  1659,  1659,  1670,  1674,  1683,  1687,
    1691,  1696,  1705,  1709,  1718,  1722,  1726,  1735,  1739,  1743,
    1747,  1751,  1755,  1759,  1763,  1767,  1771,  1775,  1779,  1783,
    1787,  1791,  1799,  1804,  1808,  1812,  1816,  1830,  1834,  1842,
    1846,  1853,  1865,  1866,  1871,  1870,  1887,  1886,  1908,  1907,
    1926,  1925,  1949,  1953,  1966,  1970,  1974,  1978,  1982,  1986,
    1990,  1994,  1998,  2002,  2007,  2023,  2027,  2032,  2039,  2046,
    2054,  2062,  2065,  2069,  2076,  2080,  2087,  2087,  2092,  2092,
    2100,  2107,  2115,  2118,  2122,  2129,  2133,  2137,  2144,  2148,
    2152,  2152,  2160,  2159,  2171,  2181,  2185,  2189,  2193,  2197,
    2201,  2206,  2213,  2221,  2224,  2228,  2235,  2239,  2246,  2253,
    2258,  2262,  2269,  2276,  2283,  2291,  2294,  2298,  2305,  2309,
    2316,  2323,  2331,  2334,  2338,  2345,  2349,  2353,  2360,  2367,
    2375,  2378,  2382,  2389,  2393,  2401,  2410,  2419,  2422,  2426,
    2434,  2438,  2446,  2446,  2451,  2457,  2464,  2471,  2478,  2482,
    2489,  2497,  2504,  2511,  2518,  2525,  2529,  2536,  2536,  2544,
    2551,  2558,  2565,  2565,  2571,  2571,  2576,  2576,  2581,  2581,
    2586,  2586,  2591,  2595,  2599,  2599,  2604,  2604,  2612,  2616,
    2620,  2624,  2628,  2632,  2636,  2640,  2647,  2654,  2669,  2687,
    2713,  2717,  2725,  2733,  2732,  2745,  2748,  2752,  2759,  2763,
    2767,  2771,  2775,  2782,  2786,  2790,  2794,  2801,  2805,  2814,
    2813,  2830,  2839,  2838,  2851,  2854,  2858,  2865,  2869,  2873,
    2877,  2884,  2888,  2895,  2900,  2907,  2915,  2923,  2926,  2930,
    2937,  2941,  2945,  2949,  2953,  2957,  2964,  2970
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "START_SYMBOL_EXPRESSION",
  "START_SYMBOL_BLOCKLIST", "IDENTIFIER", "TYPE_NAME", "CONSTANT",
  "STRING_LITERAL", "PTR_OP", "INC_OP", "DEC_OP", "LEFT_OP", "RIGHT_OP",
  "LE_OP", "GE_OP", "EQ_OP", "NE_OP", "AND_OP", "OR_OP", "MUL_ASSIGN",
  "DIV_ASSIGN", "MOD_ASSIGN", "ADD_ASSIGN", "SUB_ASSIGN", "LEFT_ASSIGN",
  "RIGHT_ASSIGN", "AND_ASSIGN", "XOR_ASSIGN", "OR_ASSIGN", "SIZEOF",
  "TYPEDEF", "EXTERN", "STATIC", "AUTO", "REGISTER", "RESTRICT", "CHAR",
  "SHORT", "INT", "LONG", "SIGNED", "UNSIGNED", "FLOAT", "DOUBLE", "CONST",
  "VOLATILE", "VOID", "INLINE", "UBOOL", "UCOMPLEX", "UIMAGINARY",
  "STRUCT", "UNION", "ENUM", "ELLIPSIS", "CASE", "DEFAULT", "IF", "ELSE",
  "SWITCH", "WHILE", "DO", "FOR", "GOTO", "CONTINUE", "BREAK", "RETURN",
  "__BUILTIN_VA_ARG", "__BUILTIN_OFFSETOF", "__BUILTIN_TYPES_COMPATIBLE_P",
  "__ATTRIBUTE__", "PRAGMA_OMP", "PRAGMA_OMP_THREADPRIVATE",
  "OMP_PARALLEL", "OMP_SECTIONS", "OMP_NOWAIT", "OMP_ORDERED",
  "OMP_SCHEDULE", "OMP_STATIC", "OMP_DYNAMIC", "OMP_GUIDED", "OMP_RUNTIME",
  "OMP_AUTO", "OMP_SECTION", "OMP_AFFINITY", "OMP_SINGLE", "OMP_MASTER",
  "OMP_CRITICAL", "OMP_BARRIER", "OMP_ATOMIC", "OMP_FLUSH", "OMP_PRIVATE",
  "OMP_FIRSTPRIVATE", "OMP_LASTPRIVATE", "OMP_SHARED", "OMP_DEFAULT",
  "OMP_NONE", "OMP_REDUCTION", "OMP_COPYIN", "OMP_NUMTHREADS",
  "OMP_COPYPRIVATE", "OMP_FOR", "OMP_IF", "OMP_TASK", "OMP_UNTIED",
  "OMP_TASKWAIT", "OMP_COLLAPSE", "PRAGMA_OMPIX", "OMPIX_TASKDEF",
  "OMPIX_IN", "OMPIX_OUT", "OMPIX_INOUT", "OMPIX_TASKSYNC",
  "OMPIX_UPONRETURN", "OMPIX_ATNODE", "OMPIX_DETACHED", "OMPIX_ATWORKER",
  "OMPIX_TASKSCHEDULE", "OMPIX_STRIDE", "OMPIX_START", "OMPIX_SCOPE",
  "OMPIX_NODES", "OMPIX_WORKERS", "OMPIX_LOCAL", "OMPIX_GLOBAL",
  "OMPIX_TIED", "'('", "')'", "'['", "']'", "'.'", "'{'", "'}'", "','",
  "'&'", "'*'", "'+'", "'-'", "'~'", "'!'", "'/'", "'%'", "'<'", "'>'",
  "'^'", "'|'", "'?'", "':'", "'='", "';'", "'\\n'", "$accept",
  "start_trick", "enumeration_constant", "string_literal",
  "primary_expression", "postfix_expression", "argument_expression_list",
  "unary_expression", "unary_operator", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "AND_expression",
  "exclusive_OR_expression", "inclusive_OR_expression",
  "logical_AND_expression", "logical_OR_expression",
  "conditional_expression", "assignment_expression", "assignment_operator",
  "expression", "constant_expression", "declaration",
  "declaration_specifiers", "init_declarator_list", "init_declarator",
  "$@1", "storage_class_specifier", "type_specifier",
  "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_specifier", "enumerator_list", "enumerator",
  "type_qualifier", "function_specifier", "declarator",
  "direct_declarator", "pointer", "type_qualifier_list",
  "parameter_type_list", "parameter_list", "parameter_declaration",
  "identifier_list", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "typedef_name", "initializer",
  "initializer_list", "designation", "designator_list", "designator",
  "statement", "labeled_statement", "compound_statement", "@2",
  "block_item_list", "block_item", "expression_statement",
  "selection_statement", "iteration_statement", "iteration_statement_for",
  "jump_statement", "translation_unit", "external_declaration",
  "function_definition", "normal_function_definition", "$@3", "$@4",
  "oldstyle_function_definition", "$@5", "$@6", "declaration_list",
  "openmp_construct", "openmp_directive", "structured_block",
  "parallel_construct", "parallel_directive", "parallel_clause_optseq",
  "parallel_clause", "unique_parallel_clause", "$@7", "$@8",
  "for_construct", "for_directive", "for_clause_optseq", "for_clause",
  "unique_for_clause", "$@9", "$@10", "schedule_kind",
  "sections_construct", "sections_directive", "sections_clause_optseq",
  "sections_clause", "section_scope", "section_sequence",
  "section_directive", "single_construct", "single_directive",
  "single_clause_optseq", "single_clause", "parallel_for_construct",
  "parallel_for_directive", "parallel_for_clause_optseq",
  "parallel_for_clause", "parallel_sections_construct",
  "parallel_sections_directive", "parallel_sections_clause_optseq",
  "parallel_sections_clause", "task_construct", "task_directive",
  "task_clause_optseq", "task_clause", "unique_task_clause", "$@11",
  "master_construct", "master_directive", "critical_construct",
  "critical_directive", "region_phrase", "taskwait_directive",
  "barrier_directive", "atomic_construct", "atomic_directive",
  "flush_directive", "flush_vars", "$@12", "ordered_construct",
  "ordered_directive", "threadprivate_directive", "data_clause", "$@13",
  "$@14", "$@15", "$@16", "$@17", "$@18", "$@19", "reduction_operator",
  "variable_list", "thrprv_variable_list", "ompix_directive",
  "ox_tasksync_directive", "ox_taskschedule_directive", "$@20",
  "ox_taskschedule_clause_optseq", "ox_taskschedule_clause",
  "ox_scope_spec", "ompix_construct", "ox_taskdef_construct", "$@21",
  "ox_taskdef_directive", "$@22", "ox_taskdef_clause_optseq",
  "ox_taskdef_clause", "ox_variable_size_list", "ox_variable_size_elem",
  "ox_task_construct", "ox_task_directive", "ox_task_clause_optseq",
  "ox_task_clause", "ox_funccall_expression", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,    40,    41,    91,
      93,    46,   123,   125,    44,    38,    42,    43,    45,   126,
      33,    47,    37,    60,    62,    94,   124,    63,    58,    61,
      59,    10
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   152,   153,   153,   153,   154,   155,   155,   156,   156,
     156,   156,   157,   157,   157,   157,   157,   157,   157,   157,
     157,   157,   157,   157,   157,   157,   158,   158,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   160,   160,   160,
     160,   160,   160,   161,   161,   162,   162,   162,   162,   163,
     163,   163,   164,   164,   164,   165,   165,   165,   165,   165,
     166,   166,   166,   167,   167,   168,   168,   169,   169,   170,
     170,   171,   171,   172,   172,   173,   173,   174,   174,   174,
     174,   174,   174,   174,   174,   174,   174,   174,   175,   175,
     176,   177,   177,   177,   178,   178,   178,   178,   178,   178,
     178,   178,   179,   179,   180,   181,   180,   182,   182,   182,
     182,   182,   183,   183,   183,   183,   183,   183,   183,   183,
     183,   183,   183,   183,   183,   183,   183,   184,   184,   184,
     184,   184,   184,   185,   185,   186,   186,   187,   187,   188,
     188,   188,   188,   189,   189,   190,   190,   190,   191,   191,
     191,   191,   191,   192,   192,   193,   193,   194,   194,   194,
     195,   196,   196,   197,   197,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   197,   197,   197,   198,   198,   198,
     198,   199,   199,   200,   200,   201,   201,   202,   202,   202,
     203,   203,   204,   204,   205,   205,   205,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   206,   207,   208,
     208,   208,   209,   209,   209,   209,   210,   211,   211,   212,
     212,   212,   213,   213,   213,   213,   213,   213,   213,   213,
     214,   214,   214,   215,   216,   215,   217,   217,   218,   218,
     218,   218,   219,   219,   220,   220,   220,   221,   221,   221,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   223,   223,   223,   223,   223,   224,   224,   225,
     225,   225,   226,   226,   228,   227,   229,   227,   231,   230,
     232,   230,   233,   233,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   235,   235,   235,   236,   237,
     238,   239,   239,   239,   240,   240,   242,   241,   243,   241,
     244,   245,   246,   246,   246,   247,   247,   247,   248,   248,
     249,   248,   250,   248,   248,   251,   251,   251,   251,   251,
     251,   252,   253,   254,   254,   254,   255,   255,   256,   257,
     257,   257,   258,   259,   260,   261,   261,   261,   262,   262,
     263,   264,   265,   265,   265,   266,   266,   266,   267,   268,
     269,   269,   269,   270,   270,   271,   272,   273,   273,   273,
     274,   274,   276,   275,   275,   277,   278,   279,   280,   280,
     281,   282,   283,   284,   285,   286,   286,   288,   287,   289,
     290,   291,   293,   292,   294,   292,   295,   292,   296,   292,
     297,   292,   292,   292,   298,   292,   299,   292,   300,   300,
     300,   300,   300,   300,   300,   300,   301,   301,   302,   302,
     303,   303,   304,   306,   305,   307,   307,   307,   308,   308,
     308,   308,   308,   309,   309,   309,   309,   310,   310,   312,
     311,   311,   314,   313,   315,   315,   315,   316,   316,   316,
     316,   317,   317,   318,   318,   319,   320,   321,   321,   321,
     322,   322,   322,   322,   322,   322,   323,   323
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     1,     2,     1,     1,
       1,     3,     1,     4,     3,     4,     3,     4,     3,     3,
       3,     3,     2,     2,     6,     7,     1,     3,     1,     2,
       2,     2,     2,     4,     6,     6,     6,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     5,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     3,     1,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     3,     1,     0,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     5,
       5,     2,     2,     1,     1,     1,     2,     3,     2,     1,
       2,     1,     2,     1,     3,     1,     3,     2,     4,     5,
       5,     6,     2,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     2,     1,     3,     3,     4,     4,     5,     5,
       6,     6,     4,     5,     4,     3,     4,     1,     2,     2,
       3,     1,     2,     1,     3,     1,     3,     2,     1,     2,
       1,     3,     1,     2,     1,     1,     2,     3,     2,     3,
       3,     4,     3,     4,     2,     3,     3,     4,     1,     1,
       3,     4,     1,     2,     3,     4,     2,     1,     2,     3,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     4,     3,     2,     0,     4,     1,     2,     1,     1,
       1,     1,     1,     2,     5,     7,     5,     5,     7,     1,
       6,     7,     7,     7,     8,     8,     8,     9,     6,     7,
       7,     8,     3,     2,     2,     2,     3,     1,     2,     1,
       1,     1,     1,     1,     0,     4,     0,     3,     0,     5,
       0,     4,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     0,     2,     3,     1,     1,     0,     5,     0,     5,
       2,     4,     0,     2,     3,     1,     1,     1,     1,     4,
       0,     7,     0,     7,     4,     1,     1,     1,     1,     1,
       1,     2,     4,     0,     2,     3,     1,     1,     3,     1,
       2,     3,     3,     2,     4,     0,     2,     3,     1,     1,
       2,     5,     0,     2,     3,     1,     1,     1,     2,     5,
       0,     2,     3,     1,     1,     2,     4,     0,     2,     3,
       1,     1,     0,     5,     1,     2,     3,     2,     3,     4,
       3,     3,     3,     2,     3,     3,     4,     0,     4,     2,
       3,     5,     0,     5,     0,     5,     0,     5,     0,     5,
       0,     5,     4,     4,     0,     7,     0,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       1,     1,     3,     0,     5,     0,     2,     3,     4,     4,
       4,     1,     1,     1,     1,     3,     3,     1,     1,     0,
       4,     2,     0,     5,     0,     2,     3,     4,     4,     4,
       6,     1,     3,     1,     4,     3,     4,     0,     2,     3,
       4,     4,     4,     1,     1,     1,     3,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,   163,   208,   107,   108,   109,   110,   111,
     158,   113,   114,   115,   116,   119,   120,   117,   118,   157,
     159,   112,   160,   121,   122,   123,   133,   134,     0,     0,
       0,     0,   177,     0,   270,     0,    94,    96,   124,     0,
     125,    98,   100,   280,   161,     0,   126,     2,   267,   269,
     272,   273,    93,   271,     0,     8,     9,     6,     0,     0,
       0,     0,     0,     0,     0,    37,    38,    39,    40,    41,
      42,    10,    12,    28,    43,     0,    45,    49,    52,    55,
      60,    63,    65,    67,    69,    71,    73,    75,    88,     3,
       8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   234,   242,     0,   238,     0,   239,
     222,   223,     4,   236,   224,   225,   226,   249,   227,   228,
     240,   284,     0,   285,     0,   286,     0,   287,     0,   288,
       0,   289,     0,   294,     0,   290,     0,   291,     0,   297,
     295,   292,     0,   296,   293,     0,   241,   420,   421,   229,
     437,   438,     0,   152,     0,     0,   442,     0,   181,   179,
     178,     1,    91,     0,   102,   278,    95,    97,   131,     0,
     132,    99,   101,     0,     0,     0,     0,   162,   268,     0,
     276,   441,     0,     0,    29,    30,     0,    32,     0,     0,
       0,     0,   139,   192,   141,     0,     7,     0,    22,    23,
       0,     0,     0,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    77,     0,    43,    31,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    90,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   265,     0,   301,   333,     0,   345,     0,     0,     0,
       0,     0,   312,   367,     0,   457,     0,   423,   233,     0,
     243,   104,   237,   298,   299,   310,     0,   331,   343,   350,
     358,   365,   375,   377,   383,   389,     0,     0,     0,     5,
     155,     0,   153,   418,     0,   444,   164,   182,   180,     0,
      92,   105,     0,     0,     0,   128,     0,   135,     0,     0,
     277,   282,     0,   190,   175,   188,     0,   183,   185,     0,
       0,   165,    38,     0,     0,   274,     0,    14,     0,    26,
       0,     0,     0,     0,     0,    11,   140,     0,     0,   194,
     193,   195,   142,     0,    19,    21,    16,     0,     0,    18,
      20,    76,    46,    47,    48,    50,    51,    53,    54,    58,
      59,    56,    57,    61,    62,    64,    66,    68,    70,    72,
       0,    89,   230,     0,   232,     0,     0,     0,     0,     0,
       0,     0,   262,   266,   360,   352,     0,     0,   390,     0,
     376,     0,   378,     0,   382,   384,   387,   385,     0,     0,
       0,   381,     0,   422,   425,     0,     0,   339,     0,     0,
       0,   455,     0,     0,   148,     0,     0,     0,     0,   103,
       0,   275,     0,     0,   127,   136,     0,   138,     0,   143,
     145,     0,   283,   281,     0,   187,   194,   189,   174,     0,
     176,     0,     0,     0,   172,   167,     0,   166,    38,     0,
     440,    15,     0,     0,    33,     0,     0,     0,   204,     0,
       0,   198,    38,     0,   196,     0,     0,     0,    44,    17,
      13,     0,   231,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   392,   396,   398,   400,     0,   404,
     406,     0,   394,     0,     0,   300,   302,   304,   305,   337,
       0,   332,   334,   336,   349,     0,   344,   346,   348,     0,
     379,     0,   386,   317,   318,     0,     0,     0,   311,   313,
     315,   316,     0,   374,     0,   366,   368,   370,   371,   464,
       0,   465,     0,   463,     0,   456,   458,     0,   235,     0,
       0,   338,     0,   340,   466,     0,   149,     0,   156,   150,
     154,   391,   419,     0,     0,     0,     0,     0,   443,   445,
       0,   209,   106,   279,   129,   147,     0,   137,     0,   130,
     184,   186,   191,   169,     0,     0,   173,   168,    27,     0,
       0,     0,   206,   197,   202,   200,   205,     0,   199,    38,
       0,     0,     0,   212,     0,     0,     0,   217,    74,   244,
     246,   247,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   359,   363,   361,   364,     0,   351,   355,   356,
     353,   357,     0,     0,     0,     0,     0,     0,     0,   308,
       0,   306,   303,   335,   347,   380,   416,     0,     0,     0,
     314,   372,   369,     0,     0,   459,   432,     0,     0,     0,
     431,     0,   424,   426,   342,   341,   467,   151,     0,     0,
       0,     0,   446,     0,   144,   146,   170,   171,    34,    35,
      36,   207,   203,   201,     0,   220,   221,    24,     0,   213,
     216,   218,     0,     0,   250,     0,     0,     0,     0,     0,
       0,   258,     0,     0,     0,   362,   354,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   388,     0,
     330,   325,   326,   327,   328,   329,     0,     0,     0,     0,
      38,     0,     0,     0,     0,     0,   427,   414,   415,   411,
     409,   408,   410,   412,   413,     0,   453,     0,   451,     0,
       0,   210,     0,   219,    25,   214,     0,   245,   248,   253,
     252,     0,   251,     0,     0,     0,   260,   259,     0,     0,
       0,     0,     0,   402,   403,     0,     0,     0,     0,     0,
     417,   322,   319,   320,   324,     0,   460,   461,   462,     0,
       0,   433,   434,     0,     0,     0,   447,     0,   448,   449,
     211,   215,   256,   255,   254,     0,   261,   393,   397,   399,
     401,     0,   407,   309,   395,   307,     0,     0,   373,   428,
     429,     0,   430,     0,     0,   452,   257,     0,     0,     0,
     436,   435,   450,   454,   405,   323,   321
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    33,   290,    71,    72,    73,   328,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,   214,   106,   239,   107,   108,   163,   164,   420,
      36,    37,    38,    39,   306,   307,   193,   428,   429,    40,
     291,   292,    41,    42,    43,    44,    45,   160,   459,   317,
     318,   319,   195,   460,   341,    46,   593,   594,   595,   596,
     597,   273,   110,   111,   269,   112,   113,   114,   115,   116,
     117,   118,    47,    48,    49,    50,   302,   173,    51,   303,
     174,   312,   119,   120,   274,   121,   122,   386,   496,   497,
     707,   705,   123,   124,   399,   519,   520,   807,   806,   717,
     125,   126,   387,   502,   277,   408,   409,   127,   128,   389,
     507,   129,   130,   483,   620,   131,   132,   482,   614,   133,
     134,   400,   526,   527,   719,   135,   136,   137,   138,   393,
     139,   140,   141,   142,   143,   398,   511,   144,   145,    52,
     498,   622,   630,   623,   624,   625,   627,   628,   735,   637,
     294,   146,   147,   148,   404,   537,   653,   783,   149,   150,
     326,    54,   295,   418,   559,   737,   738,   151,   152,   402,
     536,   287
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -624
static const yytype_int16 yypact[] =
{
    2146,  1948,   777,  -624,  -624,  -624,  -624,  -624,  -624,  -624,
    -624,  -624,  -624,  -624,  -624,  -624,  -624,  -624,  -624,  -624,
    -624,  -624,  -624,  -624,  -624,  -624,  -624,  -624,    54,   -74,
     -39,    27,   238,   122,  -624,   101,  2759,  2759,  -624,    51,
    -624,  2759,  2759,     6,   -32,    71,  -624,  2196,  -624,  -624,
    -624,  -624,  -624,  -624,  2352,    44,  -624,  -624,  1989,  1989,
    2021,    77,   117,   135,  1229,  -624,  -624,  -624,  -624,  -624,
    -624,   257,  -624,   306,    89,  1948,  -624,   256,   283,   516,
      58,   522,   154,   153,   157,   313,     5,  -624,  -624,   202,
       3,  1948,   211,   224,   241,   245,   950,   259,   334,   262,
     268,   396,   780,   266,   255,  -624,   -56,  -624,   101,  -624,
    -624,  -624,   777,  -624,  -624,  -624,  -624,  -624,  -624,  -624,
    -624,  -624,   950,  -624,   327,  -624,   309,  -624,   950,  -624,
     327,  -624,   309,  -624,   950,  -624,   950,  -624,   950,  -624,
    -624,  -624,   724,  -624,  -624,   950,  -624,  -624,  -624,  -624,
    -624,  -624,   418,   322,   462,   484,  -624,   317,  -624,  -624,
     238,  -624,  -624,   -45,  -624,   203,  -624,  -624,   360,  2247,
     369,  -624,  -624,   372,  2659,  2586,  1279,   -32,  -624,    27,
    -624,   377,  1427,  1229,  -624,  -624,  1229,  -624,  1948,  2324,
    2324,     1,  2324,   163,  2324,   331,  -624,   607,  -624,  -624,
    1470,  1948,   667,  -624,  -624,  -624,  -624,  -624,  -624,  -624,
    -624,  -624,  -624,  -624,  1948,  -624,  -624,  1948,  1948,  1948,
    1948,  1948,  1948,  1948,  1948,  1948,  1948,  1948,  1948,  1948,
    1948,  1948,  1948,  1948,  1948,  1948,  1948,   950,  -624,   358,
     950,  1948,  1948,  1948,  1217,   184,   469,   900,   390,  -624,
    -624,  -624,    23,   -14,  -624,   400,  -624,   405,   -60,   412,
     435,   -59,  -624,  -624,   438,  -624,   448,  -624,  -624,   777,
    -624,   459,  -624,  -624,  -624,  -624,  1041,  -624,  -624,  -624,
    -624,  -624,  -624,  -624,  -624,  -624,   464,   465,   462,  -624,
     461,   558,  -624,  -624,    13,  -624,  -624,  -624,  -624,    27,
    -624,  -624,   372,  2659,  2324,  -624,  2275,  -624,   137,  2324,
    -624,  -624,  2534,  -624,  -624,    61,   475,   508,  -624,    40,
    1352,  -624,   540,   549,  1306,  -624,   372,  -624,    98,  -624,
     554,   560,   565,   571,   579,  -624,  -624,  2408,  1500,   106,
    -624,   240,  -624,  1573,  -624,  -624,  -624,   196,   310,  -624,
    -624,  -624,  -624,  -624,  -624,   256,   256,   283,   283,   516,
     516,   516,   516,    58,    58,   522,   154,   153,   157,   313,
     132,  -624,  -624,   950,  -624,   265,   280,   291,   588,   991,
     118,  1065,  -624,  -624,  -624,  -624,   646,   582,  -624,   890,
    -624,   712,  -624,   577,  -624,  -624,  -624,  -624,   585,   354,
    1126,  -624,   192,  -624,  -624,   587,   888,  -624,   -12,   950,
    1614,  -624,   564,  1948,  -624,    39,   592,   716,   -27,  -624,
    1646,  -624,  2534,  2431,  -624,  -624,  1948,  -624,   121,  -624,
     600,  2457,  -624,  -624,  2302,  -624,   140,  -624,  -624,  2709,
    -624,   725,   620,  1352,  -624,  -624,  1948,  -624,   630,   635,
    -624,  -624,  1948,   640,   640,  2324,   770,  2324,  -624,   649,
     650,  -624,   651,   656,   240,  2610,  1660,  1397,  -624,  -624,
    -624,  1948,  -624,   950,   950,   950,  1948,  1687,   177,  1114,
    1761,   178,  1422,  2455,  -624,  -624,  -624,  -624,   652,  -624,
    -624,   662,  -624,   663,  1449,  -624,  -624,  -624,  -624,  -624,
     570,  -624,  -624,  -624,  -624,   675,  -624,  -624,  -624,   668,
    -624,   786,  -624,  -624,  -624,   671,   672,   419,  -624,  -624,
    -624,  -624,   673,  -624,   795,  -624,  -624,  -624,  -624,  -624,
     674,  -624,   677,  -624,   239,  -624,  -624,   365,  -624,   644,
     718,  -624,   950,  -624,  -624,   294,  -624,    45,  -624,  -624,
    -624,  -624,  -624,   705,   709,   721,   726,   284,  -624,  -624,
    1397,  -624,  -624,  -624,  -624,  -624,    57,  -624,  1948,  -624,
    -624,  -624,  -624,  -624,   722,   728,  -624,  -624,  -624,   737,
     744,   745,  -624,  -624,  -624,  -624,  -624,   747,  -624,   746,
     748,  1948,   697,  -624,   574,  1646,   191,  -624,  -624,   797,
    -624,  -624,   308,   950,   328,  1798,  1834,   195,   950,   329,
    1848,  1449,  -624,  -624,  -624,  -624,   466,  -624,  -624,  -624,
    -624,  -624,   750,   752,   753,   754,    99,   756,   765,  -624,
     768,  -624,  -624,  -624,  -624,  -624,  -624,   340,   281,   892,
    -624,  -624,  -624,  2035,  1948,  -624,  -624,   774,   775,   776,
    -624,   -18,  -624,  -624,  -624,  -624,  -624,  -624,   212,   913,
     913,   913,  -624,   576,  -624,  -624,  -624,  -624,  -624,  -624,
    -624,  -624,  -624,  -624,   767,  -624,  -624,  -624,  1023,  -624,
    -624,  -624,   950,   769,  -624,   950,   950,   343,   950,   359,
    1875,  -624,   950,   950,   366,  -624,  -624,   786,   786,   786,
     786,   792,   793,   212,   786,  1948,   786,  1948,  -624,   917,
    -624,  -624,  -624,  -624,  -624,  -624,   789,   374,   796,  1948,
     798,   800,   801,  1948,  1948,   589,  -624,  -624,  -624,  -624,
    -624,  -624,  -624,  -624,  -624,   808,   830,   391,  -624,   393,
     413,  -624,  1323,  -624,  -624,  -624,  1646,  -624,  -624,  -624,
    -624,   950,  -624,   950,   950,   414,  -624,  -624,   950,   421,
     440,   442,   444,  -624,  -624,   816,   449,   451,   453,   454,
    -624,  -624,  -624,  -624,  -624,   456,  -624,  -624,  -624,   839,
     843,  -624,   791,   849,   913,  1948,  -624,   913,  -624,  -624,
    -624,  -624,  -624,  -624,  -624,   950,  -624,  -624,  -624,  -624,
    -624,   786,  -624,  -624,  -624,  -624,  1948,  1948,  -624,  -624,
    -624,   628,  -624,   468,   851,  -624,  -624,   472,   473,   533,
    -624,  -624,  -624,  -624,  -624,  -624,  -624
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -624,  -624,  -624,  -624,  -624,  -624,  -185,   -11,  -624,   -42,
     535,   541,   460,   529,   749,   762,   755,   761,   763,  -624,
     -88,  -171,  -624,    -1,  -344,     7,     4,  -624,   696,  -624,
    -624,   -46,  -624,  -624,  -211,  -232,  -117,  -624,   434,  -624,
     715,  -389,    67,  -624,   -29,   -36,   -24,  -160,  -161,  -624,
     566,  -624,  -155,  -112,  -297,   -38,  -400,   463,  -623,  -624,
     408,     8,  -624,  -146,  -624,   740,  -100,   883,  -624,  -624,
     -34,  -624,  -624,   979,  -624,   975,  -624,  -624,  -624,  -624,
    -624,   729,  -624,  -624,  -115,  -624,  -624,  -624,   548,  -446,
    -624,  -624,  -624,  -624,  -624,   526,  -461,  -624,  -624,  -624,
    -624,  -624,  -624,   544,   915,  -624,   637,  -624,  -624,  -624,
     550,  -624,  -624,  -624,   441,  -624,  -624,  -624,   443,  -624,
    -624,  -624,   532,  -624,  -624,  -624,  -624,  -624,  -624,  -624,
    -624,  -624,  -624,  -624,  -624,  -624,  -624,  -624,  -624,  -624,
     -66,  -624,  -624,  -624,  -624,  -624,  -624,  -624,   361,  -572,
    -624,  -624,  -624,  -624,  -624,  -624,   411,  -624,  -624,    86,
    -624,  -624,  -624,  -624,   506,  -622,   278,  -624,  -624,  -624,
     534,  -624
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -440
static const yytype_int16 yytable[] =
{
      89,   170,   157,   238,    35,   323,   165,    34,   159,   177,
     109,   329,   272,   278,   316,   347,   324,   332,   192,   281,
     562,   282,   619,   283,   234,   180,   550,   310,   330,   329,
     285,   331,     3,   216,   333,   334,   613,   618,   739,   740,
     166,   167,   464,   351,   289,   171,   172,   184,   185,   187,
     289,    35,   308,   155,    34,   746,   168,     4,   179,   153,
     540,   384,     3,   191,   215,   371,     3,   391,   396,   548,
     156,   553,   224,   225,   425,   336,     3,   342,   236,   271,
     215,   340,   565,   554,   555,   556,    53,   646,   385,   299,
     275,   392,   397,   423,   270,   175,   279,   176,   431,   158,
     252,   647,   648,   649,   246,   300,     3,   557,   650,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   746,
     109,   541,   161,   192,   558,   759,   760,   761,   762,   335,
     182,   194,   766,    53,   768,   236,   298,   192,  -276,   464,
     192,   416,     3,   192,   192,     3,   192,   417,   192,   442,
     325,   237,   235,   449,    31,   619,   421,   236,   550,   345,
     443,   407,   813,    32,   350,   613,   433,   463,   440,   339,
     618,   182,   549,   383,   441,   352,   353,   354,   657,   315,
     450,   311,   191,   169,    31,   191,   154,   308,   434,   308,
     338,   425,   308,    32,   701,   679,   702,    32,    31,   425,
     348,   226,   227,   437,   188,   426,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   665,   545,   451,   297,    31,   817,
     727,   728,   452,   337,   370,   338,   194,    32,   213,   329,
     375,   376,   377,   158,   189,   372,   380,   674,   374,   561,
     194,   162,   236,   194,   381,   566,   194,   194,   192,   194,
     192,   194,   190,   192,    31,   196,   236,   434,   479,   338,
     271,   567,   574,    32,    10,   575,   563,   109,   745,   430,
     471,   578,   710,    19,    20,   426,   435,   427,   265,   230,
     337,   436,   338,   156,   543,   590,   561,   529,   231,    32,
     579,   468,   581,   232,   587,   272,   308,   530,   531,   532,
     311,   236,   236,   339,   308,   197,   198,   199,   533,   432,
     591,   503,   592,   508,   469,   238,   534,   605,   610,   236,
     452,   233,   215,   521,   528,  -274,   236,  -104,   238,   248,
     680,   315,   745,   535,   529,   690,   791,   729,   730,   731,
     732,   241,   301,  -104,   530,   531,   532,   733,   734,   240,
     711,   712,   713,   714,   715,   533,   716,   465,   242,   466,
     265,   194,   243,   194,    32,   156,   194,   192,   478,   266,
     481,   472,   553,   598,   267,   192,   247,   158,   268,   561,
      97,   297,   217,   473,   554,   555,   556,   218,   219,   236,
     177,    55,   215,    56,    57,   157,    58,    59,   474,   192,
     436,   192,   249,   109,   236,   215,   615,   621,   250,   475,
     220,   221,   656,   286,   561,   236,    60,   655,   452,   432,
     513,   514,   515,   200,   503,   201,   683,   202,   315,   508,
     470,   276,   236,   315,   236,   296,   484,   485,   486,   487,
     488,   521,   489,   490,   288,   492,   685,   692,   528,   343,
     215,   516,   236,   236,    61,    62,    63,   289,   708,   315,
     646,   751,   721,   722,   709,   602,   604,   236,   607,   609,
     238,   599,   600,   601,   647,   648,   649,   753,   517,   293,
     194,   650,   304,   236,   758,   513,   514,   515,   194,   651,
     236,   309,   772,   238,   104,   518,   373,   561,   773,  -439,
     297,   484,   485,   486,   487,   488,   652,   489,   490,   786,
     492,   788,   194,    64,   194,   787,   516,   787,   222,   223,
     378,    65,    66,    67,    68,    69,    70,   430,   228,   229,
     382,   789,   795,   514,   515,   615,   251,   787,   236,   797,
     621,   388,   779,   780,   676,   709,   390,   215,   484,   485,
     486,   487,   488,   394,   489,   490,   491,   492,   798,   493,
     799,   561,   800,   516,   709,   561,   709,   802,   709,   803,
     215,   804,   805,   709,   808,   236,   395,   709,   236,   401,
     236,   410,    90,     4,    56,    57,   822,    58,    59,   403,
     824,   825,   787,   438,   687,   689,   709,   236,   301,   694,
     413,   684,   344,     4,   814,   411,   691,    60,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,   439,    91,    92,    93,   499,    94,    95,    96,
      97,    98,    99,   100,   101,    61,    62,    63,   499,   102,
      29,   826,   484,   485,   486,   487,   488,   236,   489,   490,
     444,   492,   349,     4,   484,   485,   486,   487,   488,   445,
     489,   490,   453,   492,   359,   360,   361,   362,   454,   755,
     747,   414,   415,   749,   750,   103,   752,   546,   547,   455,
     756,   757,   675,     4,   767,   456,   769,   677,   678,   741,
     742,   781,   782,   457,    64,   476,   500,   509,   775,   104,
     538,   552,    65,    66,    67,    68,    69,    70,   510,    55,
     572,    56,    57,   501,    58,    59,   512,   105,   484,   485,
     486,   487,   488,   551,   489,   490,   491,   492,   568,   493,
     573,   504,   820,   821,    60,   355,   356,   363,   364,   792,
     576,   793,   794,   357,   358,   577,   796,   484,   485,   486,
     487,   488,   467,   489,   490,   580,   492,   582,   583,   626,
     494,   584,    90,     4,    56,    57,   585,    58,    59,   629,
     631,   636,    61,    62,    63,   654,   635,   495,   638,   639,
     641,   643,   539,   816,   644,   818,   819,    60,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,   658,    91,    92,    93,   659,    94,    95,    96,
      97,    98,    99,   100,   101,    61,    62,    63,   660,   102,
      29,    64,   666,   661,   253,   254,   682,   255,   667,    65,
      66,    67,    68,    69,    70,   668,   256,   257,   258,   259,
     260,   261,   669,   670,   105,   671,   672,   697,   673,   698,
     699,   700,   262,   703,   263,   103,   264,   484,   485,   486,
     487,   488,   704,   489,   490,   706,   492,   743,   522,   718,
     523,   723,   724,   725,    64,    55,     4,    56,    57,   104,
      58,    59,    65,    66,    67,    68,    69,    70,   736,   748,
     763,   764,   770,   771,   774,   811,   776,   105,   777,   778,
      60,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    90,   784,    56,    57,   785,
      58,    59,   253,   254,   801,   255,   504,   809,    61,    62,
      63,   810,   539,    29,   256,   257,   258,   812,   260,   365,
      60,   823,   484,   485,   486,   487,   488,   367,   489,   490,
     262,   492,   263,   366,   368,   419,    55,   369,    56,    57,
     664,    58,    59,   412,   681,   571,    91,    92,    93,   405,
      94,    95,    96,    97,    98,    99,   100,   101,    61,    62,
      63,    60,   244,   663,   505,   284,   178,    64,    55,   181,
      56,    57,   422,    58,    59,    65,    66,    67,    68,    69,
      70,   506,   632,   640,   633,   542,    90,   280,    56,    57,
     379,    58,    59,    60,   695,   634,   642,   696,   245,    61,
      62,    63,   726,   662,   765,   815,     0,     0,   645,     0,
      55,    60,    56,    57,     0,    58,    59,    64,     0,     0,
       0,     0,   104,     0,     0,    65,    66,    67,    68,    69,
      70,    61,    62,    63,     0,    60,     0,    91,    92,    93,
     105,    94,    95,    96,    97,    98,    99,   100,   101,    61,
      62,    63,     0,   406,     0,     0,     0,     0,    64,    55,
       0,    56,    57,     0,    58,    59,    65,    66,    67,    68,
      69,    70,     0,    61,    62,    63,     0,     0,     0,     0,
       0,   477,     0,     0,    60,     0,     0,     0,     0,   245,
      64,     0,   591,     0,   592,   560,   744,     0,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    64,     0,
       0,     0,     0,   104,     0,     0,    65,    66,    67,    68,
      69,    70,    61,    62,    63,     0,     0,     0,     0,     0,
       0,   105,    64,     0,     0,     0,     0,     0,     0,     0,
      65,    66,    67,    68,    69,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   480,     0,     0,   484,   485,
     486,   487,   488,     0,   489,   490,     0,   492,     0,   522,
       0,   523,     0,     0,    55,     4,    56,    57,     0,    58,
      59,    64,     0,     0,     0,     0,     0,     0,     0,    65,
      66,    67,    68,    69,    70,     0,     0,     0,     0,    60,
     524,     0,     0,     0,   606,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,   525,    23,    24,
      25,    26,    27,    28,    55,     0,    56,    57,     0,    58,
      59,   253,   254,     0,   255,     0,     0,    61,    62,    63,
       0,     0,     0,   256,   257,   258,     0,   260,     0,    60,
       0,    55,   320,    56,    57,    10,    58,    59,     0,   262,
       0,   263,     0,     0,    19,    20,     0,     0,    55,     0,
      56,    57,     0,    58,    59,     0,    60,     0,     0,   446,
       0,     0,    10,     0,     0,     0,     0,    61,    62,    63,
       0,    19,    20,    60,     0,     0,    64,    55,     0,    56,
      57,     0,    58,    59,    65,    66,    67,    68,    69,    70,
       0,     0,     0,     0,    61,    62,    63,     0,     0,     0,
       0,     0,    60,     0,     0,     0,     0,     0,    10,     0,
       0,    61,    62,    63,     0,     0,     0,    19,    20,     0,
       0,     0,    55,     0,    56,    57,    64,    58,    59,   321,
       0,     0,     0,     0,    65,   322,    67,    68,    69,    70,
      61,    62,    63,     0,     0,     0,     0,    60,     0,     0,
       0,     0,    55,    64,    56,    57,   447,    58,    59,     0,
       0,    65,   448,    67,    68,    69,    70,     0,     0,     0,
      64,     0,   591,     0,   592,   560,   790,    60,    65,    66,
      67,    68,    69,    70,     0,    61,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    55,     0,    56,    57,    64,
      58,    59,     0,     0,     0,     0,     0,    65,    66,    67,
      68,    69,    70,     0,     0,    61,    62,    63,     0,     0,
      60,     0,     0,     0,     0,    55,     0,    56,    57,     0,
      58,    59,     0,     0,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,    64,   493,   591,     0,   592,   560,
      60,     0,    65,    66,    67,    68,    69,    70,    61,    62,
      63,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,     0,   493,     0,    64,   327,   611,     0,     0,     0,
       0,     0,    65,    66,    67,    68,    69,    70,    61,    62,
      63,     0,     0,   612,     0,     0,     0,     0,    55,     0,
      56,    57,     0,    58,    59,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    64,   346,     0,
       0,     0,     0,    60,     0,    65,    66,    67,    68,    69,
      70,     0,     0,     0,     0,     0,     0,     0,     0,    55,
       0,    56,    57,     0,    58,    59,     0,    64,     0,     0,
     461,     0,     0,     0,     0,    65,   462,    67,    68,    69,
      70,    61,    62,    63,    60,     0,     0,     0,     0,     0,
       0,    55,     0,    56,    57,     0,    58,    59,     0,     0,
       0,     0,     0,     0,     0,    55,     0,    56,    57,     0,
      58,    59,     0,     0,     0,     0,    60,     0,     0,     0,
       0,     0,    61,    62,    63,     0,     0,     0,     0,     0,
      60,     0,    55,     0,    56,    57,     0,    58,    59,     0,
      64,     0,     0,     0,     0,   467,     0,     0,    65,    66,
      67,    68,    69,    70,    61,    62,    63,    60,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    61,    62,
      63,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    64,   544,     0,     0,     0,     0,     0,     0,    65,
      66,    67,    68,    69,    70,    61,    62,    63,     0,     0,
       0,     0,     0,     0,     0,     0,    55,     0,    56,    57,
       0,    58,    59,    64,     0,     0,     0,     0,   560,     0,
       0,    65,    66,    67,    68,    69,    70,    64,     0,     0,
     588,    60,     0,     0,     0,    65,   589,    67,    68,    69,
      70,     0,     0,    55,     0,    56,    57,     0,    58,    59,
       0,     0,     0,     0,    64,   603,     0,     0,     0,     0,
       0,     0,    65,    66,    67,    68,    69,    70,    60,    61,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    55,
       0,    56,    57,     0,    58,    59,     0,     0,     0,     0,
       0,     0,     0,    55,     0,    56,    57,     0,    58,    59,
       0,     0,     0,     0,    60,     0,    61,    62,    63,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    60,     0,
      55,     0,    56,    57,     0,    58,    59,     0,    64,   608,
       0,     0,     0,     0,     0,     0,    65,    66,    67,    68,
      69,    70,    61,    62,    63,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    61,    62,    63,     0,
       0,     0,     0,     0,     0,    64,   686,     0,     0,     0,
       0,     0,     0,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    61,    62,    63,     0,     0,     0,     0,
       0,     0,     0,    55,     0,    56,    57,     0,    58,    59,
       0,    64,   688,     0,     0,     0,     0,     0,     0,    65,
      66,    67,    68,    69,    70,    64,   693,     0,    60,     0,
       0,     0,     0,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,     0,    55,     0,    56,    57,     0,    58,
      59,     0,    64,   754,     0,     0,     0,     0,     0,     0,
      65,    66,    67,    68,    69,    70,    61,    62,    63,    60,
       0,     0,     0,     0,     0,     0,    55,     0,    56,    57,
       0,    58,    59,     0,     0,     0,     0,     0,     0,     0,
      55,     0,    56,    57,     0,    58,    59,     0,     0,     0,
       0,    60,     0,     0,     0,     0,     0,    61,    62,    63,
       0,     0,     0,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    64,     0,     0,     0,     0,
       0,     0,     0,    65,    66,    67,    68,    69,    70,    61,
      62,    63,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    61,    62,    63,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   183,     0,     0,     0,
       0,     0,     0,     0,    65,    66,    67,    68,    69,    70,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   186,     1,
       2,     3,     4,     0,     0,     0,    65,    66,    67,    68,
      69,    70,    64,     0,     0,     0,     0,     0,     0,     0,
      65,   720,    67,    68,    69,    70,     0,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,     3,     4,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,     0,     0,     4,    30,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
       0,     4,    32,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,     0,    23,    24,    25,    26,
      27,    28,     0,     0,    30,     0,     0,     3,     4,     0,
       0,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    31,    23,    24,    25,    26,    27,    28,
       4,     0,    32,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,     3,     4,     0,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,     0,    23,    24,    25,    26,    27,    28,     0,
     305,     0,     0,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,     0,   424,     0,
       0,     0,     0,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   434,
     458,   338,     0,     0,     0,     0,     0,     4,    32,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,     4,     0,     0,     0,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    31,
      23,    24,    25,    26,    27,    28,     0,     0,    32,     0,
       0,     0,     0,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,     0,    23,    24,    25,    26,
      27,    28,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   514,   515,     0,   337,   458,   338,     0,     0,
       4,     0,     0,     0,    32,     0,     0,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,     0,   493,     0,
       0,     0,   516,     0,   564,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,   616,
     569,   313,     4,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   617,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,     4,   104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   314,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    29,     0,     0,     0,     0,     0,   586,     0,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   570,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28
};

static const yytype_int16 yycheck[] =
{
       1,    39,    31,    91,     0,   176,    35,     0,    32,    45,
       2,   182,   112,   128,   175,   200,   176,   188,    64,   134,
     420,   136,   483,   138,    19,    54,   415,   173,   183,   200,
     145,   186,     5,    75,   189,   190,   482,   483,   660,   661,
      36,    37,   339,   214,     5,    41,    42,    58,    59,    60,
       5,    47,   169,   127,    47,   678,     5,     6,    54,     5,
      72,    75,     5,    64,    75,   236,     5,   127,   127,   413,
     109,    98,    14,    15,   306,   192,     5,   194,   134,   108,
      91,   193,   426,   110,   111,   112,     0,   105,   102,   134,
     124,   151,   151,   304,   150,   127,   130,   129,   309,    32,
     101,   119,   120,   121,    96,   150,     5,   134,   126,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,   742,
     112,   133,     0,   169,   151,   697,   698,   699,   700,   128,
     127,    64,   704,    47,   706,   134,   160,   183,   132,   436,
     186,   128,     5,   189,   190,     5,   192,   134,   194,   320,
     179,   148,   147,   324,   127,   616,   302,   134,   547,   197,
     320,   276,   784,   136,   202,   611,   312,   338,   128,   193,
     616,   127,   133,   150,   134,   217,   218,   219,   133,   175,
     326,   174,   183,   132,   127,   186,   132,   304,   127,   306,
     129,   423,   309,   136,    95,   595,    97,   136,   127,   431,
     201,   143,   144,   315,   127,   148,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   568,   410,   128,   160,   127,   801,
      18,    19,   134,   127,   235,   129,   169,   136,   149,   410,
     241,   242,   243,   176,   127,   237,   247,   591,   240,   420,
     183,   150,   134,   186,   247,   134,   189,   190,   304,   192,
     306,   194,   127,   309,   127,     8,   134,   127,   150,   129,
     299,   150,   443,   136,    36,   446,   422,   269,   678,   308,
     148,   452,     1,    45,    46,   148,   315,   150,   104,   135,
     127,   315,   129,   109,   409,   466,   467,   105,   145,   136,
     455,   343,   457,   146,   465,   405,   423,   115,   116,   117,
     303,   134,   134,   337,   431,     9,    10,    11,   126,   312,
     129,   387,   131,   389,   128,   413,   134,   150,   150,   134,
     134,    18,   343,   399,   400,   132,   134,   134,   426,     5,
     149,   337,   742,   151,   105,   150,   746,   135,   136,   137,
     138,   127,   149,   150,   115,   116,   117,   145,   146,   148,
      79,    80,    81,    82,    83,   126,    85,   127,   127,   129,
     104,   304,   127,   306,   136,   109,   309,   423,   379,   113,
     381,   373,    98,   471,   118,   431,   127,   320,   133,   560,
      63,   324,   136,   128,   110,   111,   112,   141,   142,   134,
     436,     5,   413,     7,     8,   434,    10,    11,   128,   455,
     434,   457,   150,   405,   134,   426,   482,   483,   150,   128,
     137,   138,   128,     5,   595,   134,    30,   542,   134,   422,
      76,    77,    78,   127,   500,   129,   128,   131,   434,   505,
     130,   132,   134,   439,   134,   128,    92,    93,    94,    95,
      96,   517,    98,    99,   132,   101,   128,   128,   524,   128,
     471,   107,   134,   134,    68,    69,    70,     5,   128,   465,
     105,   128,   643,   644,   134,   476,   477,   134,   479,   480,
     568,   473,   474,   475,   119,   120,   121,   128,   134,     5,
     423,   126,   132,   134,   128,    76,    77,    78,   431,   134,
     134,   132,   128,   591,   132,   151,   148,   678,   134,   132,
     443,    92,    93,    94,    95,    96,   151,    98,    99,   128,
     101,   128,   455,   127,   457,   134,   107,   134,    12,    13,
      61,   135,   136,   137,   138,   139,   140,   566,    16,    17,
     150,   128,   128,    77,    78,   611,   150,   134,   134,   128,
     616,   151,   723,   724,   592,   134,   151,   568,    92,    93,
      94,    95,    96,   151,    98,    99,   100,   101,   128,   103,
     128,   742,   128,   107,   134,   746,   134,   128,   134,   128,
     591,   128,   128,   134,   128,   134,   151,   134,   134,   151,
     134,   127,     5,     6,     7,     8,   128,    10,    11,   151,
     128,   128,   134,   128,   605,   606,   134,   134,   149,   610,
     149,   603,     5,     6,   785,   150,   608,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   134,    56,    57,    58,    76,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    76,    72,
      73,   128,    92,    93,    94,    95,    96,   134,    98,    99,
     130,   101,     5,     6,    92,    93,    94,    95,    96,   130,
      98,    99,   128,   101,   224,   225,   226,   227,   128,   690,
     682,   133,   134,   685,   686,   108,   688,   133,   134,   134,
     692,   693,     5,     6,   705,   134,   707,   133,   134,   133,
     134,   122,   123,   134,   127,   127,   134,     5,   719,   132,
     133,     5,   135,   136,   137,   138,   139,   140,   151,     5,
       5,     7,     8,   151,    10,    11,   151,   150,    92,    93,
      94,    95,    96,   151,    98,    99,   100,   101,   148,   103,
     130,    76,   124,   125,    30,   220,   221,   228,   229,   751,
     130,   753,   754,   222,   223,   130,   758,    92,    93,    94,
      95,    96,   132,    98,    99,     5,   101,   128,   128,   127,
     134,   130,     5,     6,     7,     8,   130,    10,    11,   127,
     127,     5,    68,    69,    70,   151,   128,   151,   127,   127,
     127,   127,    84,   795,   127,   806,   807,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   127,    56,    57,    58,   127,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,   127,    72,
      73,   127,   130,   127,    74,    75,    59,    77,   130,   135,
     136,   137,   138,   139,   140,   128,    86,    87,    88,    89,
      90,    91,   128,   128,   150,   128,   130,   127,   130,   127,
     127,   127,   102,   127,   104,   108,   106,    92,    93,    94,
      95,    96,   127,    98,    99,   127,   101,   130,   103,     7,
     105,   127,   127,   127,   127,     5,     6,     7,     8,   132,
      10,    11,   135,   136,   137,   138,   139,   140,     5,   150,
     128,   128,     5,   134,   128,   134,   128,   150,   128,   128,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,     5,   148,     7,     8,   129,
      10,    11,    74,    75,   148,    77,    76,   128,    68,    69,
      70,   128,    84,    73,    86,    87,    88,   128,    90,   230,
      30,   130,    92,    93,    94,    95,    96,   232,    98,    99,
     102,   101,   104,   231,   233,   299,     5,   234,     7,     8,
     566,    10,    11,   288,   596,   439,    56,    57,    58,   269,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    30,    72,   560,   134,   142,    47,   127,     5,    54,
       7,     8,   303,    10,    11,   135,   136,   137,   138,   139,
     140,   151,   494,   517,   500,   408,     5,   132,     7,     8,
     150,    10,    11,    30,   611,   505,   524,   616,   108,    68,
      69,    70,   651,   557,   703,   787,    -1,    -1,   534,    -1,
       5,    30,     7,     8,    -1,    10,    11,   127,    -1,    -1,
      -1,    -1,   132,    -1,    -1,   135,   136,   137,   138,   139,
     140,    68,    69,    70,    -1,    30,    -1,    56,    57,    58,
     150,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    -1,    -1,    -1,    -1,   127,     5,
      -1,     7,     8,    -1,    10,    11,   135,   136,   137,   138,
     139,   140,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,   150,    -1,    -1,    30,    -1,    -1,    -1,    -1,   108,
     127,    -1,   129,    -1,   131,   132,   133,    -1,   135,   136,
     137,   138,   139,   140,    -1,    -1,    -1,    -1,   127,    -1,
      -1,    -1,    -1,   132,    -1,    -1,   135,   136,   137,   138,
     139,   140,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,   150,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,   136,   137,   138,   139,   140,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   150,    -1,    -1,    92,    93,
      94,    95,    96,    -1,    98,    99,    -1,   101,    -1,   103,
      -1,   105,    -1,    -1,     5,     6,     7,     8,    -1,    10,
      11,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
     136,   137,   138,   139,   140,    -1,    -1,    -1,    -1,    30,
     134,    -1,    -1,    -1,   150,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,   151,    49,    50,
      51,    52,    53,    54,     5,    -1,     7,     8,    -1,    10,
      11,    74,    75,    -1,    77,    -1,    -1,    68,    69,    70,
      -1,    -1,    -1,    86,    87,    88,    -1,    90,    -1,    30,
      -1,     5,    33,     7,     8,    36,    10,    11,    -1,   102,
      -1,   104,    -1,    -1,    45,    46,    -1,    -1,     5,    -1,
       7,     8,    -1,    10,    11,    -1,    30,    -1,    -1,    33,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    68,    69,    70,
      -1,    45,    46,    30,    -1,    -1,   127,     5,    -1,     7,
       8,    -1,    10,    11,   135,   136,   137,   138,   139,   140,
      -1,    -1,    -1,    -1,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    68,    69,    70,    -1,    -1,    -1,    45,    46,    -1,
      -1,    -1,     5,    -1,     7,     8,   127,    10,    11,   130,
      -1,    -1,    -1,    -1,   135,   136,   137,   138,   139,   140,
      68,    69,    70,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,     5,   127,     7,     8,   130,    10,    11,    -1,
      -1,   135,   136,   137,   138,   139,   140,    -1,    -1,    -1,
     127,    -1,   129,    -1,   131,   132,   133,    30,   135,   136,
     137,   138,   139,   140,    -1,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,     7,     8,   127,
      10,    11,    -1,    -1,    -1,    -1,    -1,   135,   136,   137,
     138,   139,   140,    -1,    -1,    68,    69,    70,    -1,    -1,
      30,    -1,    -1,    -1,    -1,     5,    -1,     7,     8,    -1,
      10,    11,    -1,    -1,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   127,   103,   129,    -1,   131,   132,
      30,    -1,   135,   136,   137,   138,   139,   140,    68,    69,
      70,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,   103,    -1,   127,   128,   134,    -1,    -1,    -1,
      -1,    -1,   135,   136,   137,   138,   139,   140,    68,    69,
      70,    -1,    -1,   151,    -1,    -1,    -1,    -1,     5,    -1,
       7,     8,    -1,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,   128,    -1,
      -1,    -1,    -1,    30,    -1,   135,   136,   137,   138,   139,
     140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,
      -1,     7,     8,    -1,    10,    11,    -1,   127,    -1,    -1,
     130,    -1,    -1,    -1,    -1,   135,   136,   137,   138,   139,
     140,    68,    69,    70,    30,    -1,    -1,    -1,    -1,    -1,
      -1,     5,    -1,     7,     8,    -1,    10,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,     7,     8,    -1,
      10,    11,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      30,    -1,     5,    -1,     7,     8,    -1,    10,    11,    -1,
     127,    -1,    -1,    -1,    -1,   132,    -1,    -1,   135,   136,
     137,   138,   139,   140,    68,    69,    70,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,   135,
     136,   137,   138,   139,   140,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,     7,     8,
      -1,    10,    11,   127,    -1,    -1,    -1,    -1,   132,    -1,
      -1,   135,   136,   137,   138,   139,   140,   127,    -1,    -1,
     130,    30,    -1,    -1,    -1,   135,   136,   137,   138,   139,
     140,    -1,    -1,     5,    -1,     7,     8,    -1,    10,    11,
      -1,    -1,    -1,    -1,   127,   128,    -1,    -1,    -1,    -1,
      -1,    -1,   135,   136,   137,   138,   139,   140,    30,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,
      -1,     7,     8,    -1,    10,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     5,    -1,     7,     8,    -1,    10,    11,
      -1,    -1,    -1,    -1,    30,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,
       5,    -1,     7,     8,    -1,    10,    11,    -1,   127,   128,
      -1,    -1,    -1,    -1,    -1,    -1,   135,   136,   137,   138,
     139,   140,    68,    69,    70,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,   135,   136,   137,   138,   139,   140,    -1,
      -1,    -1,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     5,    -1,     7,     8,    -1,    10,    11,
      -1,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,   135,
     136,   137,   138,   139,   140,   127,   128,    -1,    30,    -1,
      -1,    -1,    -1,   135,   136,   137,   138,   139,   140,    -1,
      -1,    -1,    -1,    -1,     5,    -1,     7,     8,    -1,    10,
      11,    -1,   127,   128,    -1,    -1,    -1,    -1,    -1,    -1,
     135,   136,   137,   138,   139,   140,    68,    69,    70,    30,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,     7,     8,
      -1,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       5,    -1,     7,     8,    -1,    10,    11,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,   136,   137,   138,   139,   140,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,   136,   137,   138,   139,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,     3,
       4,     5,     6,    -1,    -1,    -1,   135,   136,   137,   138,
     139,   140,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,   136,   137,   138,   139,   140,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,     6,   108,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     6,   136,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    -1,    -1,   108,    -1,    -1,     5,     6,    -1,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,   127,    49,    50,    51,    52,    53,    54,
       6,    -1,   136,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,     5,     6,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    54,    -1,
     133,    -1,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,   133,    -1,
      -1,    -1,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
     128,   129,    -1,    -1,    -1,    -1,    -1,     6,   136,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,     6,    -1,    -1,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,   127,
      49,    50,    51,    52,    53,    54,    -1,    -1,   136,    -1,
      -1,    -1,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    78,    -1,   127,   128,   129,    -1,    -1,
       6,    -1,    -1,    -1,   136,    -1,    -1,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,   103,    -1,
      -1,    -1,   107,    -1,   133,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,   134,
     133,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     6,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,     6,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,   128,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,   128,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,     4,     5,     6,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    73,
     108,   127,   136,   153,   177,   178,   182,   183,   184,   185,
     191,   194,   195,   196,   197,   198,   207,   224,   225,   226,
     227,   230,   291,   311,   313,     5,     7,     8,    10,    11,
      30,    68,    69,    70,   127,   135,   136,   137,   138,   139,
     140,   155,   156,   157,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   175,
       5,    56,    57,    58,    60,    61,    62,    63,    64,    65,
      66,    67,    72,   108,   132,   150,   175,   177,   178,   213,
     214,   215,   217,   218,   219,   220,   221,   222,   223,   234,
     235,   237,   238,   244,   245,   252,   253,   259,   260,   263,
     264,   267,   268,   271,   272,   277,   278,   279,   280,   282,
     283,   284,   285,   286,   289,   290,   303,   304,   305,   310,
     311,   319,   320,     5,   132,   127,   109,   196,   194,   198,
     199,     0,   150,   179,   180,   196,   178,   178,     5,   132,
     207,   178,   178,   229,   232,   127,   129,   197,   225,   178,
     196,   227,   127,   127,   159,   159,   127,   159,   127,   127,
     127,   175,   183,   188,   194,   204,     8,     9,    10,    11,
     127,   129,   131,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,   149,   174,   159,   161,   136,   141,   142,
     137,   138,    12,    13,    14,    15,   143,   144,    16,    17,
     135,   145,   146,    18,    19,   147,   134,   148,   172,   176,
     148,   127,   127,   127,    72,   108,   213,   127,     5,   150,
     150,   150,   175,    74,    75,    77,    86,    87,    88,    89,
      90,    91,   102,   104,   106,   104,   113,   118,   133,   216,
     150,   196,   218,   213,   236,   222,   132,   256,   236,   222,
     256,   236,   236,   236,   219,   236,     5,   323,   132,     5,
     154,   192,   193,     5,   302,   314,   128,   194,   198,   134,
     150,   149,   228,   231,   132,   133,   186,   187,   188,   132,
     215,   177,   233,     5,   128,   178,   200,   201,   202,   203,
      33,   130,   136,   173,   199,   196,   312,   128,   158,   173,
     204,   204,   173,   204,   204,   128,   188,   127,   129,   198,
     205,   206,   188,   128,     5,   207,   128,   158,   175,     5,
     207,   173,   161,   161,   161,   162,   162,   163,   163,   164,
     164,   164,   164,   165,   165,   166,   167,   168,   169,   170,
     175,   173,   213,   148,   213,   175,   175,   175,    61,   150,
     175,   177,   150,   150,    75,   102,   239,   254,   151,   261,
     151,   127,   151,   281,   151,   151,   127,   151,   287,   246,
     273,   151,   321,   151,   306,   217,    72,   236,   257,   258,
     127,   150,   192,   149,   133,   134,   128,   134,   315,   180,
     181,   215,   233,   186,   133,   187,   148,   150,   189,   190,
     196,   186,   177,   215,   127,   196,   198,   205,   128,   134,
     128,   134,   173,   199,   130,   130,    33,   130,   136,   173,
     215,   128,   134,   128,   128,   134,   134,   134,   128,   200,
     205,   130,   136,   173,   206,   127,   129,   132,   161,   128,
     130,   148,   213,   128,   128,   128,   127,   150,   175,   150,
     150,   175,   269,   265,    92,    93,    94,    95,    96,    98,
      99,   100,   101,   103,   134,   151,   240,   241,   292,    76,
     134,   151,   255,   292,    76,   134,   151,   262,   292,     5,
     151,   288,   151,    76,    77,    78,   107,   134,   151,   247,
     248,   292,   103,   105,   134,   151,   274,   275,   292,   105,
     115,   116,   117,   126,   134,   151,   322,   307,   133,    84,
      72,   133,   258,   236,   128,   158,   133,   134,   176,   133,
     193,   151,     5,    98,   110,   111,   112,   134,   151,   316,
     132,   173,   208,   215,   133,   176,   134,   150,   148,   133,
      55,   202,     5,   130,   173,   173,   130,   130,   173,   204,
       5,   204,   128,   128,   130,   130,   128,   200,   130,   136,
     173,   129,   131,   208,   209,   210,   211,   212,   172,   213,
     213,   213,   175,   128,   175,   150,   150,   175,   128,   175,
     150,   134,   151,   241,   270,   292,   134,   151,   241,   248,
     266,   292,   293,   295,   296,   297,   127,   298,   299,   127,
     294,   127,   240,   255,   262,   128,     5,   301,   127,   127,
     247,   127,   274,   127,   127,   322,   105,   119,   120,   121,
     126,   134,   151,   308,   151,   236,   128,   133,   127,   127,
     127,   127,   316,   209,   190,   176,   130,   130,   128,   128,
     128,   128,   130,   130,   176,     5,   207,   133,   134,   208,
     149,   212,    59,   128,   213,   128,   128,   175,   128,   175,
     150,   213,   128,   128,   175,   270,   266,   127,   127,   127,
     127,    95,    97,   127,   127,   243,   127,   242,   128,   134,
       1,    79,    80,    81,    82,    83,    85,   251,     7,   276,
     136,   173,   173,   127,   127,   127,   308,    18,    19,   135,
     136,   137,   138,   145,   146,   300,     5,   317,   318,   317,
     317,   133,   134,   130,   133,   208,   210,   213,   150,   213,
     213,   128,   213,   128,   128,   175,   213,   213,   128,   301,
     301,   301,   301,   128,   128,   300,   301,   175,   301,   175,
       5,   134,   128,   134,   128,   175,   128,   128,   128,   173,
     173,   122,   123,   309,   148,   129,   128,   134,   128,   128,
     133,   208,   213,   213,   213,   128,   213,   128,   128,   128,
     128,   148,   128,   128,   128,   128,   250,   249,   128,   128,
     128,   134,   128,   317,   173,   318,   213,   301,   175,   175,
     124,   125,   128,   130,   128,   128,   128
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 302 "parser.y"
    { /* to avoid warnings */ }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 303 "parser.y"
    { pastree_expr = (yyvsp[(2) - (2)].expr); }
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 304 "parser.y"
    { pastree_stmt = (yyvsp[(2) - (2)].stmt); }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 322 "parser.y"
    {
      symbol s = Symbol((yyvsp[(1) - (1)].name));
      if (checkDecls) 
      {
        if ( symtab_get(stab, s, LABELNAME) )  /* NOT a type name */
          parse_error(-1, "enum symbol '%s' is already in use.", (yyvsp[(1) - (1)].name));
        symtab_put(stab, s, LABELNAME);
      }
      (yyval.symb) = s;
    }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 343 "parser.y"
    {
      (yyval.string) = strdup((yyvsp[(1) - (1)].name));
    }
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 347 "parser.y"
    {
      /* Or we could leave it as is (as a SpaceList) */
      if (((yyvsp[(1) - (2)].string) = realloc((yyvsp[(1) - (2)].string), strlen((yyvsp[(1) - (2)].string)) + strlen((yyvsp[(2) - (2)].name)))) == NULL)
        parse_error(-1, "string out of memory\n");
      strcpy(((yyvsp[(1) - (2)].string))+(strlen((yyvsp[(1) - (2)].string))-1),((yyvsp[(2) - (2)].name))+1);  /* Catenate on the '"' */
      (yyval.string) = (yyvsp[(1) - (2)].string);
    }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 370 "parser.y"
    {
      symbol  id = Symbol((yyvsp[(1) - (1)].name));
      stentry e;
      int     chflag = 0;
    
      if (checkDecls)
      {
        check_uknown_var((yyvsp[(1) - (1)].name));
        /* The parser constructs the original AST; this is the only
         * place it doesn't (actually there is one more place, when replacing
         * the "main" function): threadprivate variables are replaced on the
         * fly by pointers. This makes the job of later stages much smoother,
         * but the produced AST is semantically incorrect.
         */
        if ((e = symtab_get(stab, id, IDNAME)) != NULL) /* could be enum name */
          if (istp(e) && threadmode)
            chflag = 1;
      }
      (yyval.expr) = chflag ? UnaryOperator(UOP_paren,
                             UnaryOperator(UOP_star, Identifier(id)))
                  : Identifier(id);
    }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 393 "parser.y"
    {
      (yyval.expr) = Constant( strdup((yyvsp[(1) - (1)].name)) );
    }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 397 "parser.y"
    {
      (yyval.expr) = String((yyvsp[(1) - (1)].string));
    }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 401 "parser.y"
    {
      (yyval.expr) = UnaryOperator(UOP_paren, (yyvsp[(2) - (3)].expr));
    }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 409 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 413 "parser.y"
    {
      (yyval.expr) = ArrayIndex((yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr));
    }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 423 "parser.y"
    {
      /* Catch calls to "main()" (unlikely but possible) */
      (yyval.expr) = strcmp((yyvsp[(1) - (3)].name), "main") ?
             FunctionCall(Identifier(Symbol((yyvsp[(1) - (3)].name))), NULL) :
             FunctionCall(Identifier(Symbol(MAIN_NEWNAME)), NULL);
    }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 430 "parser.y"
    {
      /* Catch calls to "main()" (unlikely but possible) */
      (yyval.expr) = strcmp((yyvsp[(1) - (4)].name), "main") ?
             FunctionCall(Identifier(Symbol((yyvsp[(1) - (4)].name))), (yyvsp[(3) - (4)].expr)) :
             FunctionCall(Identifier(Symbol(MAIN_NEWNAME)), (yyvsp[(3) - (4)].expr));
    }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 437 "parser.y"
    {
      (yyval.expr) = FunctionCall((yyvsp[(1) - (3)].expr), NULL);
    }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 441 "parser.y"
    {
      (yyval.expr) = FunctionCall((yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr));
    }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 445 "parser.y"
    {
      (yyval.expr) = DotField((yyvsp[(1) - (3)].expr), Symbol((yyvsp[(3) - (3)].name)));
    }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 449 "parser.y"
    {
      (yyval.expr) = PtrField((yyvsp[(1) - (3)].expr), Symbol((yyvsp[(3) - (3)].name)));
    }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 458 "parser.y"
    {
      (yyval.expr) = DotField((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].symb));
    }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 462 "parser.y"
    {
      (yyval.expr) = PtrField((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].symb));
    }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 466 "parser.y"
    {
      (yyval.expr) = PostOperator((yyvsp[(1) - (2)].expr), UOP_inc);
    }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 470 "parser.y"
    {
      (yyval.expr) = PostOperator((yyvsp[(1) - (2)].expr), UOP_dec);
    }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 474 "parser.y"
    {
      (yyval.expr) = CastedExpr((yyvsp[(2) - (6)].decl), BracedInitializer((yyvsp[(5) - (6)].expr)));
    }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 478 "parser.y"
    {
      (yyval.expr) = CastedExpr((yyvsp[(2) - (7)].decl), BracedInitializer((yyvsp[(5) - (7)].expr)));
    }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 486 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr); 
    }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 490 "parser.y"
    {
      (yyval.expr) = CommaList((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 498 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 502 "parser.y"
    {
      (yyval.expr) = PreOperator((yyvsp[(2) - (2)].expr), UOP_inc);
    }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 506 "parser.y"
    {
      (yyval.expr) = PreOperator((yyvsp[(2) - (2)].expr), UOP_dec);
    }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 510 "parser.y"
    {
      if ((yyvsp[(1) - (2)].type) == -1)
        (yyval.expr) = (yyvsp[(2) - (2)].expr);                    /* simplify */
      else
        (yyval.expr) = UnaryOperator((yyvsp[(1) - (2)].type), (yyvsp[(2) - (2)].expr));
    }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 517 "parser.y"
    {
      (yyval.expr) = Sizeof((yyvsp[(2) - (2)].expr));
    }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 521 "parser.y"
    {
      (yyval.expr) = Sizeoftype((yyvsp[(3) - (4)].decl));
    }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 530 "parser.y"
    {
      (yyval.expr) = FunctionCall(Identifier(Symbol("__builtin_va_arg")),
                        CommaList((yyvsp[(3) - (6)].expr), TypeTrick((yyvsp[(5) - (6)].decl))));
    }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 535 "parser.y"
    {
      (yyval.expr) = FunctionCall(Identifier(Symbol("__builtin_offsetof")),
                        CommaList(TypeTrick((yyvsp[(3) - (6)].decl)), Identifier(Symbol((yyvsp[(5) - (6)].name)))));
    }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 540 "parser.y"
    {
      (yyval.expr) = FunctionCall(Identifier(Symbol("__builtin_types_compatible_p")),
                        CommaList(TypeTrick((yyvsp[(3) - (6)].decl)), TypeTrick((yyvsp[(5) - (6)].decl))));
    }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 549 "parser.y"
    {
      (yyval.type) = UOP_addr;
    }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 553 "parser.y"
    {
      (yyval.type) = UOP_star;
    }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 557 "parser.y"
    {
      (yyval.type) = -1;         /* Ingore this one */
    }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 561 "parser.y"
    {
      (yyval.type) = UOP_neg;
    }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 565 "parser.y"
    {
      (yyval.type) = UOP_bnot;
    }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 569 "parser.y"
    {
      (yyval.type) = UOP_lnot;
    }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 577 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 581 "parser.y"
    {
      (yyval.expr) = CastedExpr((yyvsp[(2) - (4)].decl), (yyvsp[(4) - (4)].expr));
    }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 589 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 593 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_mul, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 597 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_div, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 601 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_mod, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 609 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 613 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_add, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 617 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_sub, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 625 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 629 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_shl, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 633 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_shr, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 641 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 645 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_lt, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 649 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_gt, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 653 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_leq, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
     }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 657 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_geq, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 665 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 669 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_eqeq, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 673 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_neq, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 681 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 685 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_band, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 693 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 697 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_xor, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 705 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 709 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_bor, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 717 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 721 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_land, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 729 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 733 "parser.y"
    {
      (yyval.expr) = BinaryOperator(BOP_lor, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 741 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 745 "parser.y"
    {
      (yyval.expr) = ConditionalExpr((yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr));
    }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 753 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 757 "parser.y"
    {
      (yyval.expr) = Assignment((yyvsp[(1) - (3)].expr), (yyvsp[(2) - (3)].type), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 765 "parser.y"
    {
      (yyval.type) = ASS_eq;  /* Need fix here! */
    }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 769 "parser.y"
    {
      (yyval.type) = ASS_mul;
    }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 773 "parser.y"
    {
      (yyval.type) = ASS_div;
    }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 777 "parser.y"
    {
      (yyval.type) = ASS_mod;
    }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 781 "parser.y"
    {
      (yyval.type) = ASS_add;
    }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 785 "parser.y"
    {
      (yyval.type) = ASS_sub;
    }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 789 "parser.y"
    {
      (yyval.type) = ASS_shl;
    }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 793 "parser.y"
    {
      (yyval.type) = ASS_shr;
    }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 797 "parser.y"
    {
      (yyval.type) = ASS_and;
    }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 801 "parser.y"
    {
      (yyval.type) = ASS_xor;
    }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 805 "parser.y"
    {
      (yyval.type) = ASS_or;
    }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 813 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 817 "parser.y"
    {
      (yyval.expr) = CommaList((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 825 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 839 "parser.y"
    {
      /* There is a special case which wrongly uses this rule:
       *   typedef xxx alread_known_user_type.
       * In this case the already_known_user_type (T) is re-defined,
       * and because T is known, it is not considered as a declarator,
       * but a "typedef_name", and is part of the specifier.
       * We fix it here.
       */
      if (isTypedef && (yyvsp[(1) - (2)].spec)->type == SPECLIST)
        (yyval.stmt) = Declaration((yyvsp[(1) - (2)].spec), fix_known_typename((yyvsp[(1) - (2)].spec)));
      else
        (yyval.stmt) = Declaration((yyvsp[(1) - (2)].spec), NULL);
      isTypedef = 0;
    }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 854 "parser.y"
    {
      (yyval.stmt) = Declaration((yyvsp[(1) - (3)].spec), (yyvsp[(2) - (3)].decl));
      if (checkDecls) add_declaration_links((yyvsp[(1) - (3)].spec), (yyvsp[(2) - (3)].decl));
      isTypedef = 0;
      
    }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 861 "parser.y"
    {
      (yyval.stmt) = OmpStmt(OmpConstruct(DCTHREADPRIVATE, (yyvsp[(1) - (1)].odir), NULL));
    }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 869 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 873 "parser.y"
    {
      (yyval.spec) = Speclist_right((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 877 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 881 "parser.y"
    {
      (yyval.spec) = Speclist_right((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 885 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 889 "parser.y"
    {
      (yyval.spec) = Speclist_right((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 893 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 897 "parser.y"
    {
      (yyval.spec) = Speclist_right((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 905 "parser.y"
    {
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 909 "parser.y"
    {
      (yyval.decl) = DeclList((yyvsp[(1) - (3)].decl), (yyvsp[(3) - (3)].decl));
    }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 923 "parser.y"
    {
      astdecl s = decl_getidentifier((yyvsp[(1) - (1)].decl));
      int     declkind = decl_getkind((yyvsp[(1) - (1)].decl));
      stentry e;
      
      if (!isTypedef && declkind == DFUNC && strcmp(s->u.id->name, "main") == 0)
        s->u.id = Symbol(MAIN_NEWNAME);       /* Catch main()'s declaration */
      if (checkDecls) 
      {
        e = symtab_put(stab, s->u.id, (isTypedef) ? TYPENAME :
                                       (declkind == DFUNC) ? FUNCNAME : IDNAME);
        e->isarray = (declkind == DARRAY);
      }
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 939 "parser.y"
    {
      astdecl s = decl_getidentifier((yyvsp[(1) - (2)].decl));
      int     declkind = decl_getkind((yyvsp[(1) - (2)].decl));
      stentry e;
      
      if (!isTypedef && declkind == DFUNC && strcmp(s->u.id->name, "main") == 0)
        s->u.id = Symbol(MAIN_NEWNAME);         /* Catch main()'s declaration */
      if (checkDecls) 
      {
        e = symtab_put(stab, s->u.id, (isTypedef) ? TYPENAME :
                                       (declkind == DFUNC) ? FUNCNAME : IDNAME);
        e->isarray = (declkind == DARRAY);
      }
    }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 954 "parser.y"
    {
      (yyval.decl) = InitDecl((yyvsp[(1) - (4)].decl), (yyvsp[(4) - (4)].expr));
    }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 962 "parser.y"
    {
      (yyval.spec) = StClassSpec(SPEC_typedef);    /* Just a string */
      isTypedef = 1;
    }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 967 "parser.y"
    {
      (yyval.spec) = StClassSpec(SPEC_extern);
    }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 971 "parser.y"
    {
      (yyval.spec) = StClassSpec(SPEC_static);
    }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 975 "parser.y"
    {
      (yyval.spec) = StClassSpec(SPEC_auto);
    }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 979 "parser.y"
    {
      (yyval.spec) = StClassSpec(SPEC_register);
    }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 987 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_void);
    }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 991 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_char);
    }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 995 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_short);
    }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 999 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_int);
    }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1003 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_long);
    }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1007 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_float);
    }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1011 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_double);
    }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1015 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_signed);
    }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1019 "parser.y"
    { 
      (yyval.spec) = Declspec(SPEC_unsigned);
    }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1023 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_ubool);
    }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1027 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_ucomplex);
    }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1031 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_uimaginary);
    }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1035 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1039 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1043 "parser.y"
    {
      (yyval.spec) = Usertype((yyvsp[(1) - (1)].symb));
    }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1051 "parser.y"
    {
      (yyval.spec) = SUdecl((yyvsp[(1) - (4)].type), NULL, (yyvsp[(3) - (4)].decl));
    }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1055 "parser.y"
    {
      (yyval.spec) = SUdecl((yyvsp[(1) - (3)].type), NULL, NULL);
    }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1059 "parser.y"
    {
      symbol s = Symbol((yyvsp[(2) - (5)].name));
      /* Well, struct & union names have their own name space, and
       * their own scopes. I.e. they can be re-declare in nested
       * scopes. We don't do any kind of duplicate checks.
       */
      if (checkDecls) 
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[(1) - (5)].type), s, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1074 "parser.y"
    {
      symbol s = (yyvsp[(2) - (5)].symb);
      if (checkDecls) 
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[(1) - (5)].type), s, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1081 "parser.y"
    {
      symbol s = Symbol((yyvsp[(2) - (2)].name));
      if (checkDecls) 
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[(1) - (2)].type), s, NULL);
    }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1088 "parser.y"
    {
      symbol s = (yyvsp[(2) - (2)].symb);
      if (checkDecls) 
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[(1) - (2)].type), s, NULL);
    }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1099 "parser.y"
    {
      (yyval.type) = SPEC_struct;
    }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1103 "parser.y"
    {
      (yyval.type) = SPEC_union;
    }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1111 "parser.y"
    {
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1115 "parser.y"
    {
      (yyval.decl) = StructfieldList((yyvsp[(1) - (2)].decl), (yyvsp[(2) - (2)].decl));
    }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1123 "parser.y"
    {
      (yyval.decl) = StructfieldDecl((yyvsp[(1) - (3)].spec), (yyvsp[(2) - (3)].decl));
    }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1127 "parser.y"
    {
      (yyval.decl) = StructfieldDecl((yyvsp[(1) - (2)].spec), NULL);
    }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1135 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1139 "parser.y"
    {
      (yyval.spec) = Speclist_right((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1143 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1147 "parser.y"
    {
      (yyval.spec) = Speclist_right((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1155 "parser.y"
    {
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1159 "parser.y"
    {
      (yyval.decl) = DeclList((yyvsp[(1) - (3)].decl), (yyvsp[(3) - (3)].decl));
    }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1167 "parser.y"
    {
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1171 "parser.y"
    {
      (yyval.decl) = BitDecl((yyvsp[(1) - (3)].decl), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1175 "parser.y"
    {
      (yyval.decl) = BitDecl(NULL, (yyvsp[(2) - (2)].expr));
    }
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1183 "parser.y"
    {
      (yyval.spec) = Enumdecl(NULL, (yyvsp[(3) - (4)].spec));
    }
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1187 "parser.y"
    {
      symbol s = Symbol((yyvsp[(2) - (5)].name));

      if (checkDecls) 
      {
        if (symtab_get(stab, s, ENUMNAME))
          parse_error(-1, "enum name '%s' is already in use.", (yyvsp[(2) - (5)].name));
        symtab_put(stab, s, ENUMNAME);
      }
      (yyval.spec) = Enumdecl(s, (yyvsp[(4) - (5)].spec));
    }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1199 "parser.y"
    {
      (yyval.spec) = Enumdecl(NULL, (yyvsp[(3) - (5)].spec));
    }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1203 "parser.y"
    {
      symbol s = Symbol((yyvsp[(2) - (6)].name));

      if (checkDecls) 
      {
        if (symtab_get(stab, s, ENUMNAME))
          parse_error(-1, "enum name '%s' is already in use.", (yyvsp[(2) - (6)].name));
        symtab_put(stab, s, ENUMNAME);
      }
      (yyval.spec) = Enumdecl(s, (yyvsp[(4) - (6)].spec));
    }
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1215 "parser.y"
    {
      /*
      if (symtab_get(stab, s, ENUMNAME))
        parse_error(-1, "enum name '%s' is unknown.", $2);
      */
      (yyval.spec) = Enumdecl(Symbol((yyvsp[(2) - (2)].name)), NULL);
    }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1227 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1231 "parser.y"
    {
      (yyval.spec) = Enumbodylist((yyvsp[(1) - (3)].spec), (yyvsp[(3) - (3)].spec));
    }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1239 "parser.y"
    {
      (yyval.spec) = Enumerator((yyvsp[(1) - (1)].symb), NULL);
    }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1243 "parser.y"
    {
      (yyval.spec) = Enumerator((yyvsp[(1) - (3)].symb), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1251 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_const);
    }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1255 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_restrict);
    }
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1259 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_volatile);
    }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1267 "parser.y"
    {
      (yyval.spec) = Declspec(SPEC_inline);
    }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1275 "parser.y"
    {
      (yyval.decl) = Declarator(NULL, (yyvsp[(1) - (1)].decl));
    }
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1279 "parser.y"
    {
      (yyval.decl) = Declarator((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].decl));
    }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1292 "parser.y"
    {
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[(1) - (1)].name)) );
    }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1296 "parser.y"
    {
      /* Try to simplify a bit: (ident) -> ident */
      if ((yyvsp[(2) - (3)].decl)->spec == NULL && (yyvsp[(2) - (3)].decl)->decl->type == DIDENT)
        (yyval.decl) = (yyvsp[(2) - (3)].decl)->decl;
      else
        (yyval.decl) = ParenDecl((yyvsp[(2) - (3)].decl));
    }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1304 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (3)].decl), NULL, NULL);
    }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1308 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (4)].decl), (yyvsp[(3) - (4)].spec), NULL);
    }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1312 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (4)].decl), NULL, (yyvsp[(3) - (4)].expr));
    }
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1316 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (5)].decl), (yyvsp[(3) - (5)].spec), (yyvsp[(4) - (5)].expr));
    }
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1320 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (5)].decl), StClassSpec(SPEC_static), (yyvsp[(4) - (5)].expr));
    }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1324 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (6)].decl), Speclist_right( StClassSpec(SPEC_static), (yyvsp[(4) - (6)].spec) ), (yyvsp[(5) - (6)].expr));
    }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1328 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (6)].decl), Speclist_left( (yyvsp[(3) - (6)].spec), StClassSpec(SPEC_static) ), (yyvsp[(5) - (6)].expr));
    }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1332 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (4)].decl), Declspec(SPEC_star), NULL);
    }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1336 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (5)].decl), Speclist_left( (yyvsp[(3) - (5)].spec), Declspec(SPEC_star) ), NULL);
    }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1340 "parser.y"
    {
      (yyval.decl) = FuncDecl((yyvsp[(1) - (4)].decl), (yyvsp[(3) - (4)].decl));
    }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1344 "parser.y"
    {
      (yyval.decl) = FuncDecl((yyvsp[(1) - (3)].decl), NULL);
    }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1348 "parser.y"
    {
      (yyval.decl) = FuncDecl((yyvsp[(1) - (4)].decl), (yyvsp[(3) - (4)].decl));
    }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1356 "parser.y"
    {
      (yyval.spec) = Pointer();
    }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1360 "parser.y"
    {
      (yyval.spec) = Speclist_right(Pointer(), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1364 "parser.y"
    {
      (yyval.spec) = Speclist_right(Pointer(), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1368 "parser.y"
    {
      (yyval.spec) = Speclist_right( Pointer(), Speclist_left((yyvsp[(2) - (3)].spec), (yyvsp[(3) - (3)].spec)) );
    }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1376 "parser.y"
    {
      (yyval.spec) = (yyvsp[(1) - (1)].spec);
    }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1380 "parser.y"
    {
      (yyval.spec) = Speclist_left((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].spec));
    }
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1388 "parser.y"
    {
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1392 "parser.y"
    {
      (yyval.decl) = ParamList((yyvsp[(1) - (3)].decl), Ellipsis());
    }
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1400 "parser.y"
    {
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1404 "parser.y"
    {
      (yyval.decl) = ParamList((yyvsp[(1) - (3)].decl), (yyvsp[(3) - (3)].decl));
    }
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1412 "parser.y"
    {
      (yyval.decl) = ParamDecl((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].decl));
    }
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1416 "parser.y"
    {
      (yyval.decl) = ParamDecl((yyvsp[(1) - (1)].spec), NULL);
    }
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1420 "parser.y"
    {
      (yyval.decl) = ParamDecl((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].decl));
    }
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1428 "parser.y"
    {
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[(1) - (1)].name)) );
    }
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1432 "parser.y"
    {
      (yyval.decl) = IdList((yyvsp[(1) - (3)].decl), IdentifierDecl( Symbol((yyvsp[(3) - (3)].name)) ));
    }
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1440 "parser.y"
    {
      (yyval.decl) = Casttypename((yyvsp[(1) - (1)].spec), NULL);
    }
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1444 "parser.y"
    {
      (yyval.decl) = Casttypename((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].decl));
    }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1452 "parser.y"
    {
      (yyval.decl) = AbstractDeclarator((yyvsp[(1) - (1)].spec), NULL);
    }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1456 "parser.y"
    {
      (yyval.decl) = AbstractDeclarator(NULL, (yyvsp[(1) - (1)].decl));
    }
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1460 "parser.y"
    {
      (yyval.decl) = AbstractDeclarator((yyvsp[(1) - (2)].spec), (yyvsp[(2) - (2)].decl));
    }
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1468 "parser.y"
    {
      (yyval.decl) = ParenDecl((yyvsp[(2) - (3)].decl));
    }
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1472 "parser.y"
    {
      (yyval.decl) = ArrayDecl(NULL, NULL, NULL);
    }
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1476 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (3)].decl), NULL, NULL);
    }
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1480 "parser.y"
    {
      (yyval.decl) = ArrayDecl(NULL, NULL, (yyvsp[(2) - (3)].expr));
    }
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1484 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (4)].decl), NULL, (yyvsp[(3) - (4)].expr));
    }
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1488 "parser.y"
    {
      (yyval.decl) = ArrayDecl(NULL, Declspec(SPEC_star), NULL);
    }
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1492 "parser.y"
    {
      (yyval.decl) = ArrayDecl((yyvsp[(1) - (4)].decl), Declspec(SPEC_star), NULL);
    }
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1496 "parser.y"
    {
      (yyval.decl) = FuncDecl(NULL, NULL);
    }
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1500 "parser.y"
    {
      (yyval.decl) = FuncDecl((yyvsp[(1) - (3)].decl), NULL);
    }
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1504 "parser.y"
    {
      (yyval.decl) = FuncDecl(NULL, (yyvsp[(2) - (3)].decl));
    }
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1508 "parser.y"
    {
      (yyval.decl) = FuncDecl((yyvsp[(1) - (4)].decl), (yyvsp[(3) - (4)].decl));
    }
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1516 "parser.y"
    {
      (yyval.symb) = Symbol((yyvsp[(1) - (1)].name));
    }
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1524 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1528 "parser.y"
    {
      (yyval.expr) = BracedInitializer((yyvsp[(2) - (3)].expr));
    }
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1532 "parser.y"
    {
      (yyval.expr) = BracedInitializer((yyvsp[(2) - (4)].expr));
    }
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1540 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1544 "parser.y"
    {
      (yyval.expr) = Designated((yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].expr));
    }
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1548 "parser.y"
    {
      (yyval.expr) = CommaList((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
    }
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1552 "parser.y"
    {
      (yyval.expr) = CommaList((yyvsp[(1) - (4)].expr), Designated((yyvsp[(3) - (4)].expr), (yyvsp[(4) - (4)].expr)));
    }
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1560 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (2)].expr); 
    }
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1568 "parser.y"
    {
      (yyval.expr) = (yyvsp[(1) - (1)].expr);
    }
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1572 "parser.y"
    {
      (yyval.expr) = SpaceList((yyvsp[(1) - (2)].expr), (yyvsp[(2) - (2)].expr));
    }
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1580 "parser.y"
    {
      (yyval.expr) = IdxDesignator((yyvsp[(2) - (3)].expr));
    }
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1584 "parser.y"
    {
      (yyval.expr) = DotDesignator( Symbol((yyvsp[(2) - (2)].name)) );
    }
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1588 "parser.y"
    {
      (yyval.expr) = DotDesignator((yyvsp[(2) - (2)].symb));
    }
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1602 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1606 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1610 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1614 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1618 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1622 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1626 "parser.y"
    {
      (yyval.stmt) = OmpStmt((yyvsp[(1) - (1)].ocon));
      (yyval.stmt)->l = (yyvsp[(1) - (1)].ocon)->l;
    }
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1631 "parser.y"
    {
      (yyval.stmt) = OmpixStmt((yyvsp[(1) - (1)].xcon));
      (yyval.stmt)->l = (yyvsp[(1) - (1)].xcon)->l;
    }
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1640 "parser.y"
    {
      (yyval.stmt) = Labeled( Symbol((yyvsp[(1) - (3)].name)), (yyvsp[(3) - (3)].stmt) );
    }
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1644 "parser.y"
    {
      (yyval.stmt) = Case((yyvsp[(2) - (4)].expr), (yyvsp[(4) - (4)].stmt));
    }
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1648 "parser.y"
    {
      (yyval.stmt) = Default((yyvsp[(3) - (3)].stmt));
    }
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1656 "parser.y"
    {
      (yyval.stmt) = Compound(NULL);
    }
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1659 "parser.y"
    { (yyval.type) = sc_original_line()-1; scope_start(stab); }
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1661 "parser.y"
    {
      (yyval.stmt) = Compound((yyvsp[(3) - (4)].stmt));
      scope_end(stab);
      (yyval.stmt)->l = (yyvsp[(2) - (4)].type);     /* Remember 1st line */
    }
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1671 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1675 "parser.y"
    {
      (yyval.stmt) = BlockList((yyvsp[(1) - (2)].stmt), (yyvsp[(2) - (2)].stmt));
      (yyval.stmt)->l = (yyvsp[(1) - (2)].stmt)->l;
    }
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1684 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1688 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1692 "parser.y"
    {
      (yyval.stmt) = OmpStmt((yyvsp[(1) - (1)].ocon));
      (yyval.stmt)->l = (yyvsp[(1) - (1)].ocon)->l;
    }
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1697 "parser.y"
    {
      (yyval.stmt) = OmpixStmt((yyvsp[(1) - (1)].xcon));
      (yyval.stmt)->l = (yyvsp[(1) - (1)].xcon)->l;
    }
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1706 "parser.y"
    {
      (yyval.stmt) = Expression(NULL);
    }
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1710 "parser.y"
    {
      (yyval.stmt) = Expression((yyvsp[(1) - (2)].expr));
      (yyval.stmt)->l = (yyvsp[(1) - (2)].expr)->l;
    }
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1719 "parser.y"
    {
      (yyval.stmt) = If((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].stmt), NULL);
    }
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1723 "parser.y"
    {
      (yyval.stmt) = If((yyvsp[(3) - (7)].expr), (yyvsp[(5) - (7)].stmt), (yyvsp[(7) - (7)].stmt));
    }
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1727 "parser.y"
    {
      (yyval.stmt) = Switch((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].stmt));
    }
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1736 "parser.y"
    {
      (yyval.stmt) = While((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].stmt));
    }
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1740 "parser.y"
    {
      (yyval.stmt) = Do((yyvsp[(2) - (7)].stmt), (yyvsp[(5) - (7)].expr));
    }
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1748 "parser.y"
    {
      (yyval.stmt) = For(NULL, NULL, NULL, (yyvsp[(6) - (6)].stmt));
    }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1752 "parser.y"
    {
      (yyval.stmt) = For(Expression((yyvsp[(3) - (7)].expr)), NULL, NULL, (yyvsp[(7) - (7)].stmt));
    }
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1756 "parser.y"
    {
      (yyval.stmt) = For(NULL, (yyvsp[(4) - (7)].expr), NULL, (yyvsp[(7) - (7)].stmt));
    }
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1760 "parser.y"
    {
      (yyval.stmt) = For(NULL, NULL, (yyvsp[(5) - (7)].expr), (yyvsp[(7) - (7)].stmt));
    }
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1764 "parser.y"
    {
      (yyval.stmt) = For(Expression((yyvsp[(3) - (8)].expr)), (yyvsp[(5) - (8)].expr), NULL, (yyvsp[(8) - (8)].stmt));
    }
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1768 "parser.y"
    {
      (yyval.stmt) = For(Expression((yyvsp[(3) - (8)].expr)), NULL, (yyvsp[(6) - (8)].expr), (yyvsp[(8) - (8)].stmt));
    }
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1772 "parser.y"
    {
      (yyval.stmt) = For(NULL, (yyvsp[(4) - (8)].expr), (yyvsp[(6) - (8)].expr), (yyvsp[(8) - (8)].stmt));
    }
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1776 "parser.y"
    {
      (yyval.stmt) = For(Expression((yyvsp[(3) - (9)].expr)), (yyvsp[(5) - (9)].expr), (yyvsp[(7) - (9)].expr), (yyvsp[(9) - (9)].stmt));
    }
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1780 "parser.y"
    {
      (yyval.stmt) = For((yyvsp[(3) - (6)].stmt), NULL, NULL, (yyvsp[(6) - (6)].stmt));
    }
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1784 "parser.y"
    {
      (yyval.stmt) = For((yyvsp[(3) - (7)].stmt), (yyvsp[(4) - (7)].expr), NULL, (yyvsp[(7) - (7)].stmt));
    }
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1788 "parser.y"
    {
      (yyval.stmt) = For((yyvsp[(3) - (7)].stmt), NULL, (yyvsp[(5) - (7)].expr), (yyvsp[(7) - (7)].stmt));
    }
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1792 "parser.y"
    {
      (yyval.stmt) = For((yyvsp[(3) - (8)].stmt), (yyvsp[(4) - (8)].expr), (yyvsp[(6) - (8)].expr), (yyvsp[(8) - (8)].stmt));
    }
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1800 "parser.y"
    {
      /* We don't keep track of labels -- we leave it to the native compiler */
      (yyval.stmt) = Goto( Symbol((yyvsp[(2) - (3)].name)) );
    }
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1805 "parser.y"
    {
      (yyval.stmt) = Continue();
    }
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1809 "parser.y"
    {
      (yyval.stmt) = Break();
    }
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1813 "parser.y"
    {
      (yyval.stmt) = Return(NULL);
    }
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1817 "parser.y"
    {
      (yyval.stmt) = Return((yyvsp[(2) - (3)].expr));
    }
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1831 "parser.y"
    {
      (yyval.stmt) = pastree = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1835 "parser.y"
    {
      (yyval.stmt) = pastree = BlockList((yyvsp[(1) - (2)].stmt), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1843 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1847 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1854 "parser.y"
    {
      (yyval.stmt) = OmpixStmt((yyvsp[(1) - (1)].xcon));
    }
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1865 "parser.y"
    { (yyval.stmt) = (yyvsp[(1) - (1)].stmt); }
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1866 "parser.y"
    { (yyval.stmt) = (yyvsp[(1) - (1)].stmt); }
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1871 "parser.y"
    {
      if (isTypedef || (yyvsp[(2) - (2)].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      if (symtab_get(stab, decl_getidentifier_symbol((yyvsp[(2) - (2)].decl)), FUNCNAME) == NULL)
        symtab_put(stab, decl_getidentifier_symbol((yyvsp[(2) - (2)].decl)), FUNCNAME);
      
      scope_start(stab);
      ast_declare_function_params((yyvsp[(2) - (2)].decl));
    }
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1881 "parser.y"
    {
      scope_end(stab);
      check_for_main_and_declare((yyvsp[(1) - (4)].spec), (yyvsp[(2) - (4)].decl));
      (yyval.stmt) = FuncDef((yyvsp[(1) - (4)].spec), (yyvsp[(2) - (4)].decl), NULL, (yyvsp[(4) - (4)].stmt));
    }
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1887 "parser.y"
    {
      if (isTypedef || (yyvsp[(1) - (1)].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      if (symtab_get(stab, decl_getidentifier_symbol((yyvsp[(1) - (1)].decl)), FUNCNAME) == NULL)
        symtab_put(stab, decl_getidentifier_symbol((yyvsp[(1) - (1)].decl)), FUNCNAME);
      
      scope_start(stab);
      ast_declare_function_params((yyvsp[(1) - (1)].decl));
    }
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1897 "parser.y"
    {
      astspec s = Declspec(SPEC_int);  /* return type defaults to "int" */

      scope_end(stab);
      check_for_main_and_declare(s, (yyvsp[(1) - (3)].decl));
      (yyval.stmt) = FuncDef(s, (yyvsp[(1) - (3)].decl), NULL, (yyvsp[(3) - (3)].stmt));
    }
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1908 "parser.y"
    {
      if (isTypedef || (yyvsp[(2) - (2)].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      if (symtab_get(stab, decl_getidentifier_symbol((yyvsp[(2) - (2)].decl)), FUNCNAME) == NULL)
        symtab_put(stab, decl_getidentifier_symbol((yyvsp[(2) - (2)].decl)), FUNCNAME);
      
      scope_start(stab);
      /* Notice here that the function parameters are declared through
       * the declaration_list and we need to do nothing else!
       */
    }
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1920 "parser.y"
    {
      scope_end(stab);
      check_for_main_and_declare((yyvsp[(1) - (5)].spec), (yyvsp[(2) - (5)].decl));
      (yyval.stmt) = FuncDef((yyvsp[(1) - (5)].spec), (yyvsp[(2) - (5)].decl), (yyvsp[(4) - (5)].stmt), (yyvsp[(5) - (5)].stmt));
    }
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1926 "parser.y"
    {
      if (isTypedef || (yyvsp[(1) - (1)].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      if (symtab_get(stab, decl_getidentifier_symbol((yyvsp[(1) - (1)].decl)), FUNCNAME) == NULL)
        symtab_put(stab, decl_getidentifier_symbol((yyvsp[(1) - (1)].decl)), FUNCNAME);

      scope_start(stab);
      /* Notice here that the function parameters are declared through
       * the declaration_list and we need to do nothing else!
       */
    }
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1938 "parser.y"
    {
      astspec s = Declspec(SPEC_int);  /* return type defaults to "int" */

      scope_end(stab);
      check_for_main_and_declare(s, (yyvsp[(1) - (4)].decl));
      (yyval.stmt) = FuncDef(s, (yyvsp[(1) - (4)].decl), (yyvsp[(3) - (4)].stmt), (yyvsp[(4) - (4)].stmt));
    }
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1950 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1954 "parser.y"
    {
      (yyval.stmt) = BlockList((yyvsp[(1) - (2)].stmt), (yyvsp[(2) - (2)].stmt));         /* Same as block list */
    }
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1967 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1971 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1975 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1979 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1983 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1987 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1991 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1995 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1999 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 2003 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 2008 "parser.y"
    {
      (yyval.ocon) = (yyvsp[(1) - (1)].ocon);
    }
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 2024 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCBARRIER, (yyvsp[(1) - (1)].odir), NULL);
    }
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 2028 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCFLUSH, (yyvsp[(1) - (1)].odir), NULL);
    }
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2033 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCTASKWAIT, (yyvsp[(1) - (1)].odir), NULL);
    }
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 2040 "parser.y"
    {
      (yyval.stmt) = (yyvsp[(1) - (1)].stmt);
    }
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2047 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCPARALLEL, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
      (yyval.ocon)->l = (yyvsp[(1) - (2)].odir)->l;
    }
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 2055 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCPARALLEL, (yyvsp[(3) - (4)].ocla));
    }
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 2062 "parser.y"
    {
      (yyval.ocla) = NULL;
    }
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2066 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (2)].ocla), (yyvsp[(2) - (2)].ocla));
    }
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2070 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (3)].ocla), (yyvsp[(3) - (3)].ocla));
    }
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2077 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2081 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2087 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2088 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = IfClause((yyvsp[(4) - (5)].expr));
    }
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2092 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2093 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = NumthreadsClause((yyvsp[(4) - (5)].expr));
    }
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2101 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCFOR, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2108 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCFOR, (yyvsp[(3) - (4)].ocla));
    }
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2115 "parser.y"
    {
      (yyval.ocla) = NULL;
    }
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2119 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (2)].ocla), (yyvsp[(2) - (2)].ocla));
    }
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2123 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (3)].ocla), (yyvsp[(3) - (3)].ocla));
    }
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2130 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2134 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2138 "parser.y"
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2145 "parser.y"
    {
      (yyval.ocla) = PlainClause(OCORDERED);
    }
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2149 "parser.y"
    {
      (yyval.ocla) = ScheduleClause((yyvsp[(3) - (4)].type), NULL);
    }
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2152 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2153 "parser.y"
    {
      sc_start_openmp();
      if ((yyvsp[(3) - (7)].type) == OC_runtime)
        parse_error(1, "\"runtime\" schedules may not have a chunksize.\n");
      (yyval.ocla) = ScheduleClause((yyvsp[(3) - (7)].type), (yyvsp[(6) - (7)].expr));
    }
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2160 "parser.y"
    {  /* non-OpenMP schedule */
      tempsave = checkDecls;
      checkDecls = 0;   /* Because the index of the loop is usualy involved */
      sc_pause_openmp();
    }
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2166 "parser.y"
    {
      sc_start_openmp();
      checkDecls = tempsave;
      (yyval.ocla) = ScheduleClause(OC_affinity, (yyvsp[(6) - (7)].expr));
    }
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2172 "parser.y"
    {
      int n = atoi((yyvsp[(3) - (4)].name));
      if (n <= 0) 
        parse_error(1, "invalid number in collapse() clause.\n");
      (yyval.ocla) = CollapseClause(n);
    }
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2182 "parser.y"
    {
      (yyval.type) = OC_static;
    }
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2186 "parser.y"
    {
      (yyval.type) = OC_dynamic;
    }
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2190 "parser.y"
    {
      (yyval.type) = OC_guided;
    }
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2194 "parser.y"
    {
      (yyval.type) = OC_runtime;
    }
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2198 "parser.y"
    {
      (yyval.type) = OC_auto;
    }
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2201 "parser.y"
    { parse_error(1, "invalid openmp schedule type.\n"); }
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2207 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCSECTIONS, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2214 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCSECTIONS, (yyvsp[(3) - (4)].ocla));
    }
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2221 "parser.y"
    {
      (yyval.ocla) = NULL;
    }
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2225 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (2)].ocla), (yyvsp[(2) - (2)].ocla));
    }
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2229 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (3)].ocla), (yyvsp[(3) - (3)].ocla));
    }
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2236 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2240 "parser.y"
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2247 "parser.y"
    {
      (yyval.stmt) = Compound((yyvsp[(2) - (3)].stmt));
    }
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2254 "parser.y"
    {
      /* Make it look like it had a section pragma */
      (yyval.stmt) = OmpStmt( OmpConstruct(DCSECTION, OmpDirective(DCSECTION,NULL), (yyvsp[(1) - (1)].stmt)) );
    }
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2259 "parser.y"
    {
      (yyval.stmt) = OmpStmt( OmpConstruct(DCSECTION, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt)) );
    }
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2263 "parser.y"
    {
      (yyval.stmt) = BlockList((yyvsp[(1) - (3)].stmt), OmpStmt( OmpConstruct(DCSECTION, (yyvsp[(2) - (3)].odir), (yyvsp[(3) - (3)].stmt)) ));
    }
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2270 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCSECTION, NULL);
    }
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2277 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCSINGLE, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2284 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCSINGLE, (yyvsp[(3) - (4)].ocla));
    }
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2291 "parser.y"
    {
      (yyval.ocla) = NULL;
    }
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2295 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (2)].ocla), (yyvsp[(2) - (2)].ocla));
    }
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2299 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (3)].ocla), (yyvsp[(3) - (3)].ocla));
    }
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2306 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2310 "parser.y"
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2317 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCPARFOR, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2324 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCPARFOR, (yyvsp[(4) - (5)].ocla));
    }
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2331 "parser.y"
    {
      (yyval.ocla) = NULL;
    }
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2335 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (2)].ocla), (yyvsp[(2) - (2)].ocla));
    }
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2339 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (3)].ocla), (yyvsp[(3) - (3)].ocla));
    }
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2346 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2350 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2354 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2361 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCPARSECTIONS, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2368 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCPARSECTIONS, (yyvsp[(4) - (5)].ocla));
    }
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2375 "parser.y"
    {
      (yyval.ocla) = NULL;
    }
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2379 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (2)].ocla), (yyvsp[(2) - (2)].ocla));
    }
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2383 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (3)].ocla), (yyvsp[(3) - (3)].ocla));
    }
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2390 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2394 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2402 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCTASK, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
      (yyval.ocon)->l = (yyvsp[(1) - (2)].odir)->l;
    }
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2411 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCTASK, (yyvsp[(3) - (4)].ocla));
    }
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2419 "parser.y"
    {
      (yyval.ocla) = NULL;
    }
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2423 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (2)].ocla), (yyvsp[(2) - (2)].ocla));
    }
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2427 "parser.y"
    {
      (yyval.ocla) = OmpClauseList((yyvsp[(1) - (3)].ocla), (yyvsp[(3) - (3)].ocla));
    }
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2435 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2439 "parser.y"
    {
      (yyval.ocla) = (yyvsp[(1) - (1)].ocla);
    }
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2446 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2447 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = IfClause((yyvsp[(4) - (5)].expr));
    }
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2452 "parser.y"
    {
      (yyval.ocla) = PlainClause(OCUNTIED);
    }
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2458 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCMASTER, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2465 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCMASTER, NULL);
    }
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2472 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCCRITICAL, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2479 "parser.y"
    {
      (yyval.odir) = OmpCriticalDirective(NULL);
    }
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2483 "parser.y"
    {
      (yyval.odir) = OmpCriticalDirective((yyvsp[(3) - (4)].symb));
    }
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2490 "parser.y"
    {
      (yyval.symb) = Symbol((yyvsp[(2) - (3)].name));
    }
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2498 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCTASKWAIT, NULL);
    }
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2505 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCBARRIER, NULL);
    }
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2512 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCATOMIC, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2519 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCATOMIC, NULL);
    }
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2526 "parser.y"
    {
      (yyval.odir) = OmpFlushDirective(NULL);
    }
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2530 "parser.y"
    {
      (yyval.odir) = OmpFlushDirective((yyvsp[(3) - (4)].decl));
    }
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2536 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2537 "parser.y"
    {
      sc_start_openmp();
      (yyval.decl) = (yyvsp[(3) - (4)].decl);
    }
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2545 "parser.y"
    {
      (yyval.ocon) = OmpConstruct(DCORDERED, (yyvsp[(1) - (2)].odir), (yyvsp[(2) - (2)].stmt));
    }
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2552 "parser.y"
    {
      (yyval.odir) = OmpDirective(DCORDERED, NULL);
    }
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2559 "parser.y"
    {
      (yyval.odir) = OmpThreadprivateDirective((yyvsp[(3) - (5)].decl));
    }
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2565 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2566 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCPRIVATE, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2571 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2572 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCCOPYPRIVATE, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2576 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2577 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCFIRSTPRIVATE, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2581 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2582 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCLASTPRIVATE, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2586 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2587 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCSHARED, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2592 "parser.y"
    {
      (yyval.ocla) = DefaultClause(OC_defshared);
    }
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2596 "parser.y"
    {
      (yyval.ocla) = DefaultClause(OC_defnone);
    }
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2599 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2600 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = ReductionClause((yyvsp[(4) - (7)].type), (yyvsp[(6) - (7)].decl));
    }
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2604 "parser.y"
    { sc_pause_openmp(); }
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2605 "parser.y"
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCCOPYIN, (yyvsp[(4) - (5)].decl));
    }
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2613 "parser.y"
    {
      (yyval.type) = OC_plus;
    }
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2617 "parser.y"
    {
      (yyval.type) = OC_times;
    }
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2621 "parser.y"
    {
      (yyval.type) = OC_minus;
    }
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2625 "parser.y"
    {
      (yyval.type) = OC_band;
    }
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2629 "parser.y"
    {
      (yyval.type) = OC_xor;
    }
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2633 "parser.y"
    {
      (yyval.type) = OC_bor;
    }
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2637 "parser.y"
    {
      (yyval.type) = OC_land;
    }
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2641 "parser.y"
    {
      (yyval.type) = OC_lor;
    }
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2648 "parser.y"
    {
      if (checkDecls) 
        if (symtab_get(stab, Symbol((yyvsp[(1) - (1)].name)), IDNAME) == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[(1) - (1)].name));
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[(1) - (1)].name)) );
    }
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2655 "parser.y"
    {
      if (checkDecls) 
        if (symtab_get(stab, Symbol((yyvsp[(3) - (3)].name)), IDNAME) == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[(3) - (3)].name));
      (yyval.decl) = IdList((yyvsp[(1) - (3)].decl), IdentifierDecl( Symbol((yyvsp[(3) - (3)].name)) ));
    }
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2670 "parser.y"
    {
      if (checkDecls)
      {
        stentry e = symtab_get(stab, Symbol((yyvsp[(1) - (1)].name)), IDNAME);
        if (e == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[(1) - (1)].name));
        if (e->scopelevel != stab->scopelevel)
          parse_error(-1, "threadprivate directive appears at different "
                          "scope level\nfrom the one `%s' was declared.\n", (yyvsp[(1) - (1)].name));
        if (stab->scopelevel > 0)    /* Don't care for globals */
          if (speclist_getspec(e->spec, STCLASSSPEC, SPEC_static) == NULL)
            parse_error(-1, "threadprivate variable `%s' does not have static "
                            "storage type.\n", (yyvsp[(1) - (1)].name));
        e->isthrpriv = 1;   /* Mark */
      }
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[(1) - (1)].name)) );
    }
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2688 "parser.y"
    {
      if (checkDecls) 
      {
        stentry e = symtab_get(stab, Symbol((yyvsp[(3) - (3)].name)), IDNAME);
        if (e == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[(3) - (3)].name));
        if (e->scopelevel != stab->scopelevel)
          parse_error(-1, "threadprivate directive appears at different "
                          "scope level\nfrom the one `%s' was declared.\n", (yyvsp[(3) - (3)].name));
        if (stab->scopelevel > 0)    /* Don't care for globals */
          if (speclist_getspec(e->spec, STCLASSSPEC, SPEC_static) == NULL)
            parse_error(-1, "threadprivate variable `%s' does not have static "
                            "storage type.\n", (yyvsp[(3) - (3)].name));
        e->isthrpriv = 1;   /* Mark */
      }
      (yyval.decl) = IdList((yyvsp[(1) - (3)].decl), IdentifierDecl( Symbol((yyvsp[(3) - (3)].name)) ));
    }
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2714 "parser.y"
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTASKSYNC, (yyvsp[(1) - (1)].xdir), NULL);
    }
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2718 "parser.y"
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTASKSCHEDULE, (yyvsp[(1) - (1)].xdir), NULL);
    }
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2726 "parser.y"
    {
      (yyval.xdir) = OmpixDirective(OX_DCTASKSYNC, NULL);
    }
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2733 "parser.y"
    { 
      scope_start(stab); 
    }
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2737 "parser.y"
    {
      scope_end(stab);
      (yyval.xdir) = OmpixDirective(OX_DCTASKSCHEDULE, (yyvsp[(4) - (5)].xcla));
    }
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2745 "parser.y"
    {
      (yyval.xcla) = NULL;
    }
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2749 "parser.y"
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[(1) - (2)].xcla), (yyvsp[(2) - (2)].xcla));
    }
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2753 "parser.y"
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[(1) - (3)].xcla), (yyvsp[(3) - (3)].xcla));
    }
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2760 "parser.y"
    {
      (yyval.xcla) = OmpixStrideClause((yyvsp[(3) - (4)].expr));
    }
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2764 "parser.y"
    {
      (yyval.xcla) = OmpixStartClause((yyvsp[(3) - (4)].expr));
    }
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2768 "parser.y"
    {
      (yyval.xcla) = OmpixScopeClause((yyvsp[(3) - (4)].type));
    }
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2772 "parser.y"
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCTIED);
    }
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2776 "parser.y"
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCUNTIED);
    }
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2783 "parser.y"
    {
      (yyval.type) = OX_SCOPE_NODES;
    }
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2787 "parser.y"
    {
      (yyval.type) = OX_SCOPE_WGLOBAL;
    }
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2791 "parser.y"
    {
      (yyval.type) = OX_SCOPE_WGLOBAL;
    }
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2795 "parser.y"
    {
      (yyval.type) = OX_SCOPE_WLOCAL;
    }
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2802 "parser.y"
    {
      (yyval.xcon) = (yyvsp[(1) - (1)].xcon);
    }
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2806 "parser.y"
    {
      (yyval.xcon) = (yyvsp[(1) - (1)].xcon);
    }
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2814 "parser.y"
    {
      /* Should put the name of the callback function in the stab, too
      if (symtab_get(stab, decl_getidentifier_symbol($2->u.declaration.decl),
            FUNCNAME) == NULL)
        symtab_put(stab, decl_getidentifier_symbol($2->u.declaration.spec),
            FUNCNAME);
      */
      scope_start(stab);   /* re-declare the arguments of the task function */
      ast_declare_function_params((yyvsp[(2) - (2)].stmt)->u.declaration.decl);
    }
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2825 "parser.y"
    {
      scope_end(stab);
      (yyval.xcon) = OmpixTaskdef((yyvsp[(1) - (4)].xdir), (yyvsp[(2) - (4)].stmt), (yyvsp[(4) - (4)].stmt));
      (yyval.xcon)->l = (yyvsp[(1) - (4)].xdir)->l;
    }
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2831 "parser.y"
    {
      (yyval.xcon) = OmpixTaskdef((yyvsp[(1) - (2)].xdir), (yyvsp[(2) - (2)].stmt), NULL);
      (yyval.xcon)->l = (yyvsp[(1) - (2)].xdir)->l;
    }
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2839 "parser.y"
    { 
      scope_start(stab); 
    }
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2843 "parser.y"
    {
      scope_end(stab);
      (yyval.xdir) = OmpixDirective(OX_DCTASKDEF, (yyvsp[(4) - (5)].xcla));
    }
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2851 "parser.y"
    {
      (yyval.xcla) = NULL;
    }
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2855 "parser.y"
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[(1) - (2)].xcla), (yyvsp[(2) - (2)].xcla));
    }
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2859 "parser.y"
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[(1) - (3)].xcla), (yyvsp[(3) - (3)].xcla));
    }
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2866 "parser.y"
    {
      (yyval.xcla) = OmpixVarlistClause(OX_OCIN, (yyvsp[(3) - (4)].decl));
    }
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2870 "parser.y"
    {
      (yyval.xcla) = OmpixVarlistClause(OX_OCOUT, (yyvsp[(3) - (4)].decl));
    }
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2874 "parser.y"
    {
      (yyval.xcla) = OmpixVarlistClause(OX_OCINOUT, (yyvsp[(3) - (4)].decl));
    }
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2878 "parser.y"
    {
      (yyval.xcla) = OmpixReductionClause((yyvsp[(3) - (6)].type), (yyvsp[(5) - (6)].decl));
    }
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2885 "parser.y"
    {
      (yyval.decl) = (yyvsp[(1) - (1)].decl);
    }
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2889 "parser.y"
    {
      (yyval.decl) = IdList((yyvsp[(1) - (3)].decl), (yyvsp[(3) - (3)].decl));
    }
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2896 "parser.y"
    {
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[(1) - (1)].name)) );
      symtab_put(stab, Symbol((yyvsp[(1) - (1)].name)), IDNAME);
    }
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2901 "parser.y"
    {
      (yyval.decl) = ArrayDecl(IdentifierDecl( Symbol((yyvsp[(1) - (4)].name)) ), NULL, (yyvsp[(3) - (4)].expr));
    }
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2908 "parser.y"
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTASK, (yyvsp[(1) - (3)].xdir), Expression((yyvsp[(2) - (3)].expr)));
      (yyval.xcon)->l = (yyvsp[(1) - (3)].xdir)->l;
    }
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2916 "parser.y"
    {
      (yyval.xdir) = OmpixDirective(OX_DCTASK, (yyvsp[(3) - (4)].xcla));
    }
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2923 "parser.y"
    {
      (yyval.xcla) = NULL;
    }
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2927 "parser.y"
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[(1) - (2)].xcla), (yyvsp[(2) - (2)].xcla));
    }
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2931 "parser.y"
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[(1) - (3)].xcla), (yyvsp[(3) - (3)].xcla));
    }
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2938 "parser.y"
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCATALL);
    }
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2942 "parser.y"
    {
      (yyval.xcla) = OmpixAtnodeClause((yyvsp[(3) - (4)].expr));
    }
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2946 "parser.y"
    {
      (yyval.xcla) = OmpixAtworkerClause((yyvsp[(3) - (4)].expr));
    }
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2950 "parser.y"
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCTIED);
    }
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2954 "parser.y"
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCUNTIED);
    }
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2958 "parser.y"
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCDETACHED);
    }
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2965 "parser.y"
    {
      (yyval.expr) = strcmp((yyvsp[(1) - (3)].name), "main") ?
             FunctionCall(Identifier(Symbol((yyvsp[(1) - (3)].name))), NULL) :
             FunctionCall(Identifier(Symbol(MAIN_NEWNAME)), NULL);
    }
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2971 "parser.y"
    {
      (yyval.expr) = strcmp((yyvsp[(1) - (4)].name), "main") ?
             FunctionCall(Identifier(Symbol((yyvsp[(1) - (4)].name))), (yyvsp[(3) - (4)].expr)) :
             FunctionCall(Identifier(Symbol(MAIN_NEWNAME)), (yyvsp[(3) - (4)].expr));
    }
    break;



/* Line 1455 of yacc.c  */
#line 7319 "parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 2979 "parser.y"



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                                               *
 *     CODE                                                      *
 *                                                               *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


void yyerror(char *s)
{
  fprintf(stderr, "(file %s, line %d, column %d):\n\t%s\n",
                  sc_original_file(), sc_original_line(), sc_column(), s);
}


/* Check whether the identifier is known or not
 */
void check_uknown_var(char *name)
{
  symbol s = Symbol(name);
  if (symtab_get(stab, s, IDNAME) == NULL &&
      symtab_get(stab, s, LABELNAME) == NULL &&
      symtab_get(stab, s, FUNCNAME) == NULL)
    parse_error(-1, "unknown identifier `%s'.\n", name);
}



/* See the "declaration" rule: if the last element of the list
 * is a user typename, we remove it, and we return it as an
 * identifier declarator.
 * The list should have 3 elements (typedef xxx type).
 */
astdecl fix_known_typename(astspec s)
{
  astspec prev;
  astdecl d;
  
  if (s->type != SPECLIST || s->u.next->type != SPECLIST) return (NULL);
  
  for (; s->u.next->type == SPECLIST; prev = s, s = s->u.next)  
    ;   /* goto last list node */
  if (s->u.next->type != USERTYPE)         /* nope */
    return (NULL);
    
  prev->u.next = s->body;
  
  d = Declarator(NULL, IdentifierDecl(s->u.next->name));
  if (checkDecls) 
    symtab_put(stab, s->u.next->name, TYPENAME);
  free(s);
  return (d);
}


void check_for_main_and_declare(astspec s, astdecl d)
{
  astdecl n = decl_getidentifier(d);

  assert(d->type == DECLARATOR);
  assert(d->decl->type == DFUNC);
  
  if (strcmp(n->u.id->name, "main") == 0)
  {
    n->u.id = Symbol(MAIN_NEWNAME);         /* Catch main()'s definition */
    hasMainfunc = 1;

    /* Now check for return type and # parameters */
    /* It d != NULL then its parameters is either (id or idlist) or
     * (paramtype or parmatypelist). If it is a list, assume the
     * standard 2 params, otherwise, we guess the single argument
     * must be the type "void" which means no params.
     * In any case, we always force main have (argc, argv[]).
     */
    if (d->decl->u.params == NULL || d->decl->u.params->type != DLIST)
      d->decl->u.params =
          ParamList(
            ParamDecl(
              Declspec(SPEC_int),
              Declarator( NULL, IdentifierDecl( Symbol("_argc_ignored") ) )
            ),
            ParamDecl(
              Declspec(SPEC_char),
              Declarator(Speclist_right( Pointer(), Pointer() ),
                         IdentifierDecl( Symbol("_argv_ignored") ))
            )
          );
   
    mainfuncRettype = 0; /* int */
    if (s != NULL)
    {
      for (; s->type == SPECLIST && s->subtype == SPEC_Rlist; s = s->u.next)
        if (s->body->type == SPEC && s->body->subtype == SPEC_void)
        {
          s = s->body;
          break;
        };
      if (s->type == SPEC && s->subtype == SPEC_void)
        mainfuncRettype = 1; /* void */
    }
  }
  if (symtab_get(stab, n->u.id, FUNCNAME) == NULL)/* From earlier declaration */
    symtab_put(stab, n->u.id, FUNCNAME);
}


/* For each variable/typename in the given declaration, add pointers in the
 * symbol table entries back to the declaration nodes.
 */
void add_declaration_links(astspec s, astdecl d)
{
  astdecl ini = NULL;
  
  if (d->type == DLIST && d->subtype == DECL_decllist)
  {
    add_declaration_links(s, d->u.next);
    d = d->decl;
  }
  if (d->type == DINIT) d = (ini = d)->decl;   /* Skip the initializer */
  assert(d->type == DECLARATOR);
  if (d->decl != NULL && d->decl->type != ABSDECLARATOR)
  {
    symbol  t = decl_getidentifier_symbol(d->decl);
    stentry e = isTypedef ?
                symtab_get(stab,t,TYPENAME) :
                symtab_get(stab,t,(decl_getkind(d)==DFUNC) ? FUNCNAME : IDNAME);
    e->spec  = s;
    e->decl  = d;
    e->idecl = ini;
  }
}


void parse_error(int exitvalue, char *format, ...)
{
  va_list ap;

  va_start(ap, format);
  fprintf(stderr, "(%s, line %d)\n\t", sc_original_file(), sc_original_line());
  vfprintf(stderr, format, ap);
  va_end(ap);
  if (strcmp(sc_original_file(), "injected_code") == 0)
    fprintf(stderr, "\n>>>>>>>\n%s\n>>>>>>>\n", parsingstring);
  _exit(exitvalue);
}


void parse_warning(char *format, ...)
{
  va_list ap;

  va_start(ap, format);
  fprintf(stderr, "[warning] ");
  vfprintf(stderr, format, ap);
  va_end(ap);
}


aststmt parse_file(char *fname, int *error)
{
  *error = 0;
  if ( (yyin = fopen(fname, "r")) == NULL )
    return (NULL);
  sc_set_filename(fname);      /* Inform the scanner */
  *error = yyparse();
  fclose(yyin);                /* No longer needed */
  return (pastree);
}


#define PARSE_STRING_SIZE 8192


astexpr parse_expression_string(char *format, ...)
{
  static char s[PARSE_STRING_SIZE];
  int    savecD;
  
  va_list ap;
  va_start(ap, format);
  vsnprintf(s, PARSE_STRING_SIZE-1, format, ap);
  va_end(ap);
  parsingstring = s;
  sc_scan_string(s);
  sc_set_start_token(START_SYMBOL_EXPRESSION);

  savecD = checkDecls;
  checkDecls = 0;         /* Don't check identifiers & don't declare them */
  yyparse();
  checkDecls = savecD;    /* Reset it */
  return ( pastree_expr );
}


aststmt parse_blocklist_string(char *format, ...)
{
  static char s[PARSE_STRING_SIZE];
  int    savecD;

  va_list ap;
  va_start(ap, format);
  vsnprintf(s, PARSE_STRING_SIZE-1, format, ap);
  va_end(ap);
  parsingstring = s;
  sc_scan_string(s);
  sc_set_start_token(START_SYMBOL_BLOCKLIST);

  savecD = checkDecls;
  checkDecls = 0;         /* Don't check identifiers & don't declare them */
  yyparse();
  checkDecls = savecD;    /* Reset it */
  return ( pastree_stmt );
}


aststmt parse_and_declare_blocklist_string(char *format, ...)
{
  static char s[PARSE_STRING_SIZE];
  int    savecD;
  
  va_list ap;
  va_start(ap, format);
  vsnprintf(s, PARSE_STRING_SIZE-1, format, ap);
  va_end(ap);
  parsingstring = s;
  sc_scan_string(s);
  sc_set_start_token(START_SYMBOL_BLOCKLIST);

  savecD = checkDecls;
  checkDecls = 1;         /* Do check identifiers & do declare them */
  yyparse();
  checkDecls = savecD;    /* Reset it */
  return ( pastree_stmt );
}

